#!/usr/bin/env python2
###############################################################################
#                                                                             #
#        _        _____ ____ _______     _            _                       #
#       | |      / ____|  _ \__   __|   | |          | |                      #
#       | |_ __ | |  __| |_) | | |______| |_ ___  ___| |_ ___ _ __            #
#       | | '_ \| | |_ |  _ <  | |______| __/ _ \/ __| __/ _ \ '__|           #
#       | | |_) | |__| | |_) | | |      | ||  __/\__ \ ||  __/ |              #
#       |_| .__/ \_____|____/  |_|       \__\___||___/\__\___|_|              #
#         | |                                                                 #
#         |_|                                                                 #
#                                                                             #
#  Copyright (C) 2018 lpGBT Team, CERN                                        #
#                                                                             #
#  This IP block is free for HEP experiments and other scientific research    #
#  purposes. Commercial exploitation of a chip containing the IP is not       #
#  permitted.  You can not redistribute the IP without written permission     #
#  from the authors. Any modifications of the IP have to be communicated back #
#  to the authors. The use of the IP should be acknowledged in publications,  #
#  public presentations, user manual, and other documents.                    #
#                                                                             #
#  This IP is distributed in the hope that it will be useful, but WITHOUT ANY #
#  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  #
#  FOR A PARTICULAR PURPOSE.                                                  #
#                                                                             #
###############################################################################
""" Lpgbt Constants"""

class LpgbtConstants(object):
    """ Class containing all lpGBT-related constants"""

    # GPIO_CTRL inputs
    CTRL_TSTOUT0 = 0
    CTRL_TSTOUT1 = 1
    CTRL_TSTOUT2 = 2
    CTRL_TSTOUT3 = 3
    # GPIO_CTRL Ouputs
    CTRL_RSTB = 4
    CTRL_ADDR0 = 5
    CTRL_ADDR1 = 6
    CTRL_ADDR2 = 7
    CTRL_ADDR3 = 8
    CTRL_MODE0 = 9
    CTRL_MODE1 = 10
    CTRL_MODE2 = 11
    CTRL_MODE3 = 12
    CTRL_SCI2C = 13
    CTRL_LOCKMODE = 14
    CTRL_STATEOVRD = 15
    CTRL_PORDIS = 16
    CTRL_VCOBYPASS = 17
    # GPIO_CTRL inputs
    CTRL_READY = 18
    CTRL_RSTOUTB =19

    # lpGBT modes of operation
    MODE_5G_FEC5_OFF = 0
    MODE_5G_FEC5_TX = 1
    MODE_5G_FEC5_RX = 2
    MODE_5G_FEC5_TRX = 3

    MODE_5G_FEC12_OFF = 4
    MODE_5G_FEC12_TX = 5
    MODE_5G_FEC12_RX = 6
    MODE_5G_FEC12_TRX = 7

    MODE_10G_FEC5_OFF = 8
    MODE_10G_FEC5_TX = 9
    MODE_10G_FEC5_RX = 10
    MODE_10G_FEC5_TRX = 11

    MODE_10G_FEC12_OFF = 12
    MODE_10G_FEC12_TX = 13
    MODE_10G_FEC12_RX = 14
    MODE_10G_FEC12_TRX = 15

    # lpGBT configuration
    LOCKMODE_REFERENCE = 0
    LOCKMODE_REFERENCELESS = 1

    CONFIGSELECT_SC = 0
    CONFIGSELECT_I2C = 1


    EPRX_GROUPS = 7
    EPTX_GROUPS = 4
    EPCLKS = 29

    # PUSM : states
    STATE_RESET0 = 0
    STATE_RESET1 = 1
    STATE_WAIT_VDD_STABLE = 2
    STATE_WAIT_VDD_HIGHER_THAN_0V90 = 3
    STATE_FUSE_SAMPLING = 4
    STATE_UPDATE = 5
    STATE_PAUSE_FOR_PLL_CONFIG_DONE = 6
    STATE_WAIT_POWER_GOOD = 7
    STATE_RESETOUT = 8
    STATE_I2C_TRANS = 9
    STATE_RESET_PLL = 10
    STATE_WAIT_PLL_LOCK = 11
    STATE_INIT_SCRAM = 12
    STATE_PAUSE_FOR_DLL_CONFIG_DONE = 13
    STATE_RESET_DLLS = 14
    STATE_WAIT_DLL_LOCK = 15
    STATE_RESET_LOGIC_USING_DLL = 16
    STATE_WAIT_CHNS_LOCKED = 17
    STATE_READY = 18

    PUSM2STR = ["RESET0", "RESET1", "WAIT_VDD_STABLE", "STATE_WAIT_VDD_HIGHER_THAN_0V90",
                "FUSE_SAMPLING", "UPDATE", "PAUSE_FOR_PLL_CONFIG_DONE", "WAIT_POWER_GOOD",
                "RESETOUT", "I2C_TRANS", "RESET_PLL", "WAIT_PLL_LOCK", "INIT_SCRAM", 
                "PAUSE_FOR_DLL_CONFIG_DONE", "RESET_DLLS", "WAIT_DLL_LOCK", 
                "RESET_LOGIC_USING_DLL", "WAIT_CHNS_LOCKED", "READY"]

    # PUSM : reset out pulse durations
    RESETOUT_LENGTH_OFF = 0
    RESETOUT_LENGTH_100NS = 1
    RESETOUT_LENGTH_1US = 2
    RESETOUT_LENGTH_10US = 3

    # PUSM : power good delays
    POWERGOOD_DELAY_OFF = 0
    POWERGOOD_DELAY_1US = 1
    POWERGOOD_DELAY_5US = 2
    POWERGOOD_DELAY_10US = 3
    POWERGOOD_DELAY_50US = 4
    POWERGOOD_DELAY_100US = 5
    POWERGOOD_DELAY_500US = 6
    POWERGOOD_DELAY_1MS = 7
    POWERGOOD_DELAY_5MS = 8
    POWERGOOD_DELAY_10MS = 9
    POWERGOOD_DELAY_20MS = 10
    POWERGOOD_DELAY_50MS = 11
    POWERGOOD_DELAY_100MS = 12
    POWERGOOD_DELAY_200MS = 13
    POWERGOOD_DELAY_500MS = 14
    POWERGOOD_DELAY_1S = 15

    # PUSM : timeout values
    TIMEOUT_DISABLED = 15
    TIMEOUT_10US = 14
    TIMEOUT_20US = 13
    TIMEOUT_50US = 12
    TIMEOUT_100US = 11
    TIMEOUT_200US = 10
    TIMEOUT_500US = 9
    TIMEOUT_1MS = 8
    TIMEOUT_2MS = 7
    TIMEOUT_5MS = 6
    TIMEOUT_10MS = 5
    TIMEOUT_20MS = 4
    TIMEOUT_50MS = 3
    TIMEOUT_100MS = 2
    TIMEOUT_500MS = 1
    TIMEOUT_1S = 0

    # PUSM : state override magic number
    FORCESTATE_MAGIC_NUMBER = 0xa3

    # PUSM : power sensing levels
    VDD_LEVEL_0V70 = 0
    VDD_LEVEL_0V75 = 1
    VDD_LEVEL_0V80 = 2
    VDD_LEVEL_0V85 = 3
    VDD_LEVEL_0V90 = 4
    VDD_LEVEL_0V95 = 5
    VDD_LEVEL_1V00 = 6
    VDD_LEVEL_1V05 = 7

    # ePortClocks
    EPORTCLOCKS_CLKDISABLE = 0
    EPORTCLOCKS_CLK40M = 1
    EPORTCLOCKS_CLK80M = 2
    EPORTCLOCKS_CLK160M = 3
    EPORTCLOCKS_CLK320M = 4
    EPORTCLOCKS_CLK640M = 5
    EPORTCLOCKS_CLK1G28 = 6
    EPORTCLOCKS_LOOPBACK = 7

    ECLKFREQ2STR = ["DISABLE", "40M", "80M", "160M", "320M", "640M", "1280M"]

    PS_CHN0 = 0
    PS_CHN1 = 1
    PS_CHN2 = 2
    PS_CHN3 = 3

    PS_CLK40M = 1
    PS_CLK80M = 2
    PS_CLK160M = 3
    PS_CLK320M = 4
    PS_CLK640M = 5
    PS_CLK1G28 = 6


    # eTX configuration
    eTXNoPreEmp = 0
    eTXExtTimedPreEmp = 1
    eTXSelfTimedPreEmp = 2
    eTxClkTimedPreEmp = 3

    TXDATARATE_5G = 0
    TXDATARATE_10G = 1


    # up link data source
    DLDS_LINK_DATA = 0
    DLDS_PRBS7 = 1
    DLDS_BIN_CNTR_UP = 2
    DLDS_CONST_PATTERN = 3

    # BERT: 4 MSB bits of dataSource signal (dataSourceGroup)
    BC_DISABLED = 0x0
    BC_ULDG0 = 0x1
    BC_ULDG1 = 0x2
    BC_ULDG2 = 0x3
    BC_ULDG3 = 0x4
    BC_ULDG4 = 0x5
    BC_ULDG5 = 0x6
    BC_ULDG6 = 0x7
    BC_ULEC = 0x8
    BC_DLDG0 = 0x9
    BC_DLDG1 = 0xA
    BC_DLDG2 = 0xB
    BC_DLDG3 = 0xC
    BC_DLEC = 0xD
    BC_DLFRAME = 0xE

    # BERT: 4 LSB bits of dataSource signal (dataSourceChannel)
    BC_ULx4_CHN0 = 0x0
    BC_ULx4_CHN1 = 0x1
    BC_ULx4_CHN2 = 0x2
    BC_ULx4_CHN3 = 0x3
    BC_ULx2_CHN0 = 0x4
    BC_ULx2_CHN2 = 0x5
    BC_ULx1_CHN0 = 0x6
    BC_UL_FIXED = 0x7

    BC_DLx4_CHN0 = 0x0
    BC_DLx4_CHN1 = 0x1
    BC_DLx4_CHN2 = 0x2
    BC_DLx4_CHN3 = 0x3
    BC_DLx2_CHN0 = 0x4
    BC_DLx2_CHN2 = 0x5
    BC_DLx1_CHN0 = 0x6

    BC_DL_FIXED = 0x7

    BC_OTHER_DLDATA_PRBS = 0x0 # 32 bit
    BC_OTHER_DLDATA_FIXED = 0x1 # 32 bit
    BC_OTHER_DLFRAME_PRBS7 = 0x2
    BC_OTHER_DLFRAME_PRBS15 = 0x3
    BC_OTHER_DLFRAME_PRBS23 = 0x4
    BC_OTHER_DLFRAME_PRBS31 = 0x5
    BC_OTHER_DLFRAME_FIXED = 0x7

    # BERT: Measurement Time (in kilo clock cycles)
    BC_MT_2e5 = 0 # 3.200e+01 (8.0e-07s) BER : (1.6e-02 - 4.9e-04)
    BC_MT_2e7 = 1 # 1.280e+02 (3.2e-06s) BER : (3.9e-03 - 1.2e-04)
    BC_MT_2e9 = 2 # 5.120e+02 (1.3e-05s) BER : (9.8e-04 - 3.1e-05)
    BC_MT_2e11 = 3 # 2.048e+03 (5.1e-05s) BER : (2.4e-04 - 7.6e-06)
    BC_MT_2e13 = 4 # 8.192e+03 (2.0e-04s) BER : (6.1e-05 - 1.9e-06)
    BC_MT_2e15 = 5 # 3.277e+04 (8.2e-04s) BER : (1.5e-05 - 4.8e-07)
    BC_MT_2e17 = 6 # 1.311e+05 (3.3e-03s) BER : (3.8e-06 - 1.2e-07)
    BC_MT_2e19 = 7 # 5.243e+05 (1.3e-02s) BER : (9.5e-07 - 3.0e-08)
    BC_MT_2e21 = 8 # 2.097e+06 (5.2e-02s) BER : (2.4e-07 - 7.5e-09)
    BC_MT_2e23 = 9 # 8.389e+06 (2.1e-01s) BER : (6.0e-08 - 1.9e-09)
    BC_MT_2e25 = 10 # 3.355e+07 (8.4e-01s) BER : (1.5e-08 - 4.7e-10)
    BC_MT_2e27 = 11 # 1.342e+08 (3.4e+00s) BER : (3.7e-09 - 1.2e-10)
    BC_MT_2e29 = 12 # 5.369e+08 (1.3e+01s) BER : (9.3e-10 - 2.9e-11)
    BC_MT_2e31 = 13 # 2.147e+09 (5.4e+01s) BER : (2.3e-10 - 7.3e-12)
    BC_MT_2e33 = 14 # 8.590e+09 (2.1e+02s) BER : (5.8e-11 - 1.8e-12)
    BC_MT_2e35 = 15 # 3.436e+10 (8.6e+02s) BER : (1.5e-11 - 4.5e-13)

    # Phase shifter
    PHASESHIFTER_CLKDISABLE = 0
    PHASESHIFTER_CLK40M = 1
    PHASESHIFTER_CLK80M = 2
    PHASESHIFTER_CLK160M = 3
    PHASESHIFTER_CLK320M = 4
    PHASESHIFTER_CLK640M = 5
    PHASESHIFTER_CLK1G28 = 6

    PS_DELAY_STEP = 1.0/(8*1.28e9)
    # ePortRx : data rates (5.12G mode, txDataRate=1'b0)
    EPORTRXLS_IDLE = 0
    EPORTRXLS_X4 = 1
    EPORTRXLS_X8 = 2
    EPORTRXLS_X16 = 3

    # ePortRx : data rates (10.24G mode, txDataRate=1'b1)
    EPORTRXHS_IDLE = 0
    EPORTRXHS_X8 = 1
    EPORTRXHS_X16 = 2
    EPORTRXHS_X32 = 3

    # ePortRx : phase selection mode
    EPORTRXMODE_FIXED = 0
    EPORTRXMODE_AUTOSTARTUP = 1
    EPORTRXMODE_CONTINOUSTRACKING = 2
    EPORTRXMODE_CONTINOUSTRACKINGINITIALPHASE = 3

    EPORTRXDATARATE2STR = [["-", "160", "320", "640"], ["-", "320", "640", "1280"]]

    # ePortTx : data rates
    EPORTTX_IDLE = 0
    EPORTTX_X2 = 1
    EPORTTX_X4 = 2
    EPORTTX_X8 = 3

    # ADC inputs
    ADCCHN_EXT0 = 0
    ADCCHN_EXT1 = 1
    ADCCHN_EXT2 = 2
    ADCCHN_EXT3 = 3
    ADCCHN_EXT4 = 4
    ADCCHN_EXT5 = 5
    ADCCHN_EXT6 = 6
    ADCCHN_EXT7 = 7

    ADCCHN_EOMDAC = 8
    ADCCHN_VDDIO = 9
    ADCCHN_VDDTX = 10
    ADCCHN_VDDRX = 11
    ADCCHN_VDD = 12
    ADCCHN_VDDA = 13
    ADCCHN_TEMP = 14
    ADCCHN_VREF2 = 15

    # ADC gain
    ADCGAIN_X2 = 0
    ADCGAIN_X8 = 1
    ADCGAIN_X16 = 2
    ADCGAIN_X32 = 3

    # current DAC
    CURDAC_CHN0_bm = 0x01
    CURDAC_CHN1_bm = 0x02
    CURDAC_CHN2_bm = 0x04
    CURDAC_CHN3_bm = 0x08
    CURDAC_CHN4_bm = 0x10
    CURDAC_CHN5_bm = 0x20
    CURDAC_CHN6_bm = 0x40
    CURDAC_CHN7_bm = 0x80

    # Voltage DAC
    VDAC_MAX = 4096
    VREF_TUNE_MAX = 64
    VREF_NOMINAL = 1.0

    # test output
    TO_ZERO = 0
    TO_ONE = 1
    TO_CLK40MA = 4
    TO_CLK40MB = 5
    TO_CLK40MC = 6
    TO_CLK80MA = 7
    TO_CLK80MB = 8
    TO_CLK80MC = 9
    TO_CLK160MA = 10
    TO_CLK160MB = 11
    TO_CLK160MC = 12
    TO_CLK320MA = 13
    TO_CLK320MB = 14
    TO_CLK320MC = 15
    TO_CLK640MA = 16
    TO_CLK640MB = 17
    TO_CLK640MC = 18
    TO_CLK1G28A = 19
    TO_CLK1G28B = 20
    TO_CLK1G28C = 21
    TO_SEUEVENT = 22
    TO_PMCLKOUT = 23
    TO_ENDCOUNTERREFCLKV = 24
    TO_FROMCDR_CLKREF = 25
    TO_FROMCDR_INSTLOCKPLL = 26
    TO_ENDCOUNTERVCOV = 27
    TO_FUSESRAMPENABLE = 28
    TO_FUSESPOWERSHORT = 29
    TO_FUSESPOWERENABLE = 30
    TO_FUSESSCLK = 31
    TO_FUSESPGM = 32
    TO_FUSESDIN = 33
    TO_FUSESCSB = 34
    TO_PS0DLLLOCKEDV = 35
    TO_PS1DLLLOCKEDV = 36
    TO_PS2DLLLOCKEDV = 37
    TO_PS3DLLLOCKEDV = 38
    TO_PS0DLLLATEV = 39
    TO_PS1DLLLATEV = 40
    TO_PS2DLLLATEV = 41
    TO_PS3DLLLATEV = 42
    TO_PS0DLLOUTREF = 43
    TO_PS1DLLOUTREF = 44
    TO_PS2DLLOUTREF = 45
    TO_PS3DLLOUTREF = 46
    TO_EPORTRXDLLINSTANTLOCK0 = 47
    TO_EPORTRXDLLINSTANTLOCK1 = 48
    TO_EPORTRXDLLINSTANTLOCK2 = 49
    TO_EPORTRXDLLINSTANTLOCK3 = 50
    TO_EPORTRXDLLINSTANTLOCK4 = 51
    TO_EPORTRXDLLINSTANTLOCK5 = 52
    TO_EPORTRXDLLINSTANTLOCK6 = 53
    TO_EPORTRXDLLOUTREF0 = 54
    TO_EPORTRXDLLOUTREF1 = 55
    TO_EPORTRXDLLOUTREF2 = 56
    TO_EPORTRXDLLOUTREF3 = 57
    TO_EPORTRXDLLOUTREF4 = 58
    TO_EPORTRXDLLOUTREF5 = 59
    TO_EPORTRXDLLOUTREF6 = 60
    TO_DOWNLINKFRAME60 = 61
    TO_DOWNLINKFRAME61 = 62
    TO_DOWNLINKFRAME62 = 63
    TO_DOWNLINKFRAME63 = 64
    TO_EPORTRXDATAIN0 = 65
    TO_EPORTRXDATAIN1 = 66
    TO_EPORTRXDATAIN2 = 67
    TO_EPORTRXDATAIN3 = 68
    TO_EPORTRXDATAIN4 = 69
    TO_EPORTRXDATAIN5 = 70
    TO_EPORTRXDATAIN6 = 71
    TO_EPORTRXDATAIN7 = 72
    TO_EPORTRXDATAIN8 = 73
    TO_EPORTRXDATAIN9 = 74
    TO_EPORTRXDATAIN10 = 75
    TO_EPORTRXDATAIN11 = 76
    TO_EPORTRXDATAIN12 = 77
    TO_EPORTRXDATAIN13 = 78
    TO_EPORTRXDATAIN14 = 79
    TO_EPORTRXDATAIN15 = 80
    TO_EPORTRXDATAIN16 = 81
    TO_EPORTRXDATAIN17 = 82
    TO_EPORTRXDATAIN18 = 83
    TO_EPORTRXDATAIN19 = 84
    TO_EPORTRXDATAIN20 = 85
    TO_EPORTRXDATAIN21 = 86
    TO_EPORTRXDATAIN22 = 87
    TO_EPORTRXDATAIN23 = 88
    TO_EPORTRXDATAIN24 = 89
    TO_EPORTRXDATAIN25 = 90
    TO_EPORTRXDATAIN26 = 91
    TO_EPORTRXDATAIN27 = 92
    TO_PORA = 93
    TO_PORB = 94
    TO_PORC = 95
    TO_EPORTRXDATAINEC = 96
    TO_BODA = 97
    TO_BODB = 98
    TO_BODC = 99
    TO_I2CTRANSACTIONSTARTV = 100
    TO_I2CTRANSACTIONDONEV = 101
    TO_I2CMASTER_GO0_V = 102
    TO_I2CMASTER_GO1_V = 103
    TO_I2CMASTER_GO2_V = 104
    TO_SKIPCYCLERAW = 105
    TO_SKIPCYCLEV = 106
    TO_RXREADY = 107
    TO_TXREADYV = 108
    TO_PLLSTATEMACHINELOCKEDV = 109
    TO_EPORTRXDLLLOCKEDV0 = 110
    TO_EPORTRXDLLLOCKEDV1 = 111
    TO_EPORTRXDLLLOCKEDV2 = 112
    TO_EPORTRXDLLLOCKEDV3 = 113
    TO_EPORTRXDLLLOCKEDV4 = 114
    TO_EPORTRXDLLLOCKEDV5 = 115
    TO_EPORTRXDLLLOCKEDV6 = 116
    TO_EPORTRXDLLLATEV0 = 117
    TO_EPORTRXDLLLATEV1 = 118
    TO_EPORTRXDLLLATEV2 = 119
    TO_EPORTRXDLLLATEV3 = 120
    TO_EPORTRXDLLLATEV4 = 121
    TO_EPORTRXDLLLATEV5 = 122
    TO_EPORTRXDLLLATEV6 = 123
    TO_FRAMEALIGNERREADYV = 124

    # I2C Masters: Commands
    I2CM_WRITE_CRA = 0x0
    I2CM_WRITE_MSK = 0x1
    I2CM_1BYTE_WRITE = 0x2
    I2CM_1BYTE_READ = 0x3
    I2CM_1BYTE_WRITE_EXT = 0x4
    I2CM_1BYTE_READ_EXT = 0x5
    I2CM_1BYTE_RMW_OR = 0x6
    I2CM_1BYTE_RMW_XOR = 0x7
    I2CM_W_MULTI_4BYTE0 = 0x8
    I2CM_W_MULTI_4BYTE1 = 0x9
    I2CM_W_MULTI_4BYTE2 = 0xa
    I2CM_W_MULTI_4BYTE3 = 0xb
    I2CM_WRITE_MULTI = 0xc
    I2CM_READ_MULTI = 0xd
    I2CM_WRITE_MULTI_EXT = 0xe
    I2CM_READ_MULTI_EXT = 0xf

    # I2C Masters: Control Register
    I2CM_CR_FREQ_100K = 0
    I2CM_CR_FREQ_200K = 1
    I2CM_CR_FREQ_400K = 2
    I2CM_CR_FREQ_1M = 3
    I2CM_CR_FREQ_bm = 0x3
    I2CM_CR_FREQ_of = 0

    I2CM_CR_NBYTES_of = 2
    I2CM_CR_NBYTES_bm = 0x7C

    I2CM_CR_SCLDRIVE_of = 7
    I2CM_CR_SCLDRIVE_bm = 0x80

    # I2C Masters: Status Register
    I2CM_SR_SUCC_bm = 0x04
    I2CM_SR_LEVEERR_bm = 0x08
    I2CM_SR_INVCOM_bm = 0x20
    I2CM_SR_NOACK_bm = 0x40

    # Fuses
    FUSE_MAGIC_NUMBER = 0xA3

    # UpLinkSerial Pattern [3:0]
    ULSTP_DATA = 0           # Normal mode of operation
    ULSTP_PRBS7 = 1          # PRBS7 test pattern (x7 + x6 + 1)
    ULSTP_PRBS15 = 2         # PRBS15 test pattern (x15 + x14 + 1)
    ULSTP_PRBS23 = 3         # PRBS23 test pattern (x23 + x18 + 1)
    ULSTP_PRBS31 = 4         # PRBS31 test pattern (x31 + x28 + 1)
    ULSTP_CLK5G12 = 5        # 5.12 GHz clock pattern (in 5Gbps mode it will produce only 2.56 GHz)
    ULSTP_CLK2G56 = 6        # 2.56 GHz clock pattern
    ULSTP_CLK1G28 = 7        # 1.28 GHz clock pattern
    ULSTP_CLK40M = 8         # 40 MHz clock pattern
    ULSTP_DLFRAME_10G24 = 9  # Loop back, down link frame repeated 4 times
    ULSTP_DLFRAME_5G12 = 10  # Loop back, down link frame repeated 2 times, each bit repeated 2 times
    ULSTP_DLFRAME_2G56 = 11  # Loop back, down link frame repeated 1 times, each bit repeated 4 times
    ULSTP_CONST_PATTERN = 12 # 8 x DPDataPattern[31:0]


    # Lpgbt Registers
    CHIPID0 = 0x0000
    CHIPID0_CHIPID_of = 0
    CHIPID1 = 0x0001
    CHIPID1_CHIPID_of = 0
    CHIPID2 = 0x0002
    CHIPID2_CHIPID_of = 0
    CHIPID3 = 0x0003
    CHIPID3_CHIPID_of = 0
    USERID0 = 0x0004
    USERID0_USERID_of = 0
    USERID1 = 0x0005
    USERID1_USERID_of = 0
    USERID2 = 0x0006
    USERID2_USERID_of = 0
    USERID3 = 0x0007
    USERID3_USERID_of = 0
    DACCAL0 = 0x0008
    DACCAL0_DACCALMINCODE_of = 0
    DACCAL1 = 0x0009
    DACCAL1_DACCALMAXCODE_of = 0
    DACCAL2 = 0x000a
    DACCAL2_DACCALMINCODE_of = 4
    DACCAL2_DACCALMAXCODE_of = 0
    ADCCAL0 = 0x000b
    ADCCAL0_ADCCALGAIN2SEHIGH_of = 0
    ADCCAL1 = 0x000c
    ADCCAL1_ADCCALGAIN2SELOW_of = 0
    ADCCAL2 = 0x000d
    ADCCAL2_ADCCALGAIN2SEHIGH_of = 4
    ADCCAL2_ADCCALGAIN2SELOW_of = 0
    ADCCAL3 = 0x000e
    ADCCAL3_ADCCALGAIN2DIFHIGH_of = 0
    ADCCAL4 = 0x000f
    ADCCAL4_ADCCALGAIN2DIFLOW_of = 0
    ADCCAL5 = 0x0010
    ADCCAL5_ADCCALGAIN2DIFHIGH_of = 4
    ADCCAL5_ADCCALGAIN2DIRFLOW_of = 0
    ADCCAL6 = 0x0011
    ADCCAL6_ADCCALGAIN4DIFHIGH_of = 0
    ADCCAL7 = 0x0012
    ADCCAL7_ADCCALGAIN4DIFLOW_of = 0
    ADCCAL8 = 0x0013
    ADCCAL8_ADCCALGAIN4DIFHIGH_of = 4
    ADCCAL8_ADCCALGAIN4DIRFLOW_of = 0
    ADCCAL9 = 0x0014
    ADCCAL9_ADCCALGAIN8DIFHIGH_of = 0
    ADCCAL10 = 0x0015
    ADCCAL10_ADCCALGAIN8DIFLOW_of = 0
    ADCCAL11 = 0x0016
    ADCCAL11_ADCCALGAIN8DIFHIGH_of = 4
    ADCCAL11_ADCCALGAIN8DIRFLOW_of = 0
    ADCCAL12 = 0x0017
    ADCCAL12_ADCCALGAIN16DIFHIGH_of = 0
    ADCCAL13 = 0x0018
    ADCCAL13_ADCCALGAIN16DIFLOW_of = 0
    ADCCAL14 = 0x0019
    ADCCAL14_ADCCALGAIN16DIFHIGH_of = 4
    ADCCAL14_ADCCALGAIN16DIRFLOW_of = 0
    TEMPCALH = 0x001a
    TEMPCALH_TEMPCAL_of = 0
    TEMPCALL = 0x001b
    TEMPCALL_TEMPCAL_of = 0
    VREFCNTR = 0x001c
    VREFCNTR_VREFENABLE_bm = 0x80
    VREFCNTR_VREFTUNE_of = 0
    CURDACCALH = 0x001d
    CURDACCALH_CURDACCAL_of = 0
    CURDACCALL = 0x001e
    CURDACCALL_CURDACCAL_of = 0
    RESERVED0 = 0x001f
    RESERVED0_EPRXLOCKTHRESHOLD_of = 4
    RESERVED0_EPRXRELOCKTHRESHOLD_of = 0
    CLKGCONFIG0 = 0x0020
    CLKGCONFIG0_CLKGCALIBRATIONENDOFCOUNT_of = 4
    CLKGCONFIG0_CLKGBIASGENCONFIG_of = 0
    CLKGCONFIG1 = 0x0021
    CLKGCONFIG1_CRDCONTROLOVERRIDEENABLE_bm = 0x80
    CLKGCONFIG1_CLKGDISABLEFRAMEALIGNERLOCKCONTROL_bm = 0x40
    CLKGCONFIG1_CLKGCDRRES_bm = 0x20
    CLKGCONFIG1_CLKGVCORAILMODE_bm = 0x10
    CLKGCONFIG1_CLKGVCODAC_of = 0
    CLKGPLLRES = 0x0022
    CLKGPLLRES_CLKGPLLRESWHENLOCKED_of = 4
    CLKGPLLRES_CLKGPLLRES_of = 0
    CLKGPLLINTCUR = 0x0023
    CLKGPLLINTCUR_CLKGPLLINTCURWHENLOCKED_of = 4
    CLKGPLLINTCUR_CLKGPLLINTCUR_of = 0
    CLKGPLLPROPCUR = 0x0024
    CLKGPLLPROPCUR_CLKGPLLPROPCURWHENLOCKED_of = 4
    CLKGPLLPROPCUR_CLKGPLLPROPCUR_of = 0
    CLKGCDRPROPCUR = 0x0025
    CLKGCDRPROPCUR_CLKGCDRPROPCURWHENLOCKED_of = 4
    CLKGCDRPROPCUR_CLKGCDRPROPCUR_of = 0
    CLKGCDRINTCUR = 0x0026
    CLKGCDRINTCUR_CLKGCDRINTCURWHENLOCKED_of = 4
    CLKGCDRINTCUR_CLKGCDRINTCUR_of = 0
    CLKGCDRFFPROPCUR = 0x0027
    CLKGCDRFFPROPCUR_CLKGCDRFEEDFORWARDPROPCURWHENLOCKED_of = 4
    CLKGCDRFFPROPCUR_CLKGCDRFEEDFORWARDPROPCUR_of = 0
    CLKGFLLINTCUR = 0x0028
    CLKGFLLINTCUR_CLKGFLLINTCURWHENLOCKED_of = 4
    CLKGFLLINTCUR_CLKGFLLINTCUR_of = 0
    CLKGFFCAP = 0x0029
    CLKGFFCAP_CDRCOCONNECTCDR_bm = 0x80
    CLKGFFCAP_CLKGCAPBANKOVERRIDEENABLE_bm = 0x40
    CLKGFFCAP_CLKGFEEDFORWARDCAPWHENLOCKED_of = 3
    CLKGFFCAP_CLKGFEEDFORWARDCAP_of = 0
    CLKGCNTOVERRIDE = 0x002a
    CLKGCNTOVERRIDE_CLKGCOOVERRIDEVC_bm = 0x80
    CLKGCNTOVERRIDE_CDRCOREFCLKSEL_bm = 0x40
    CLKGCNTOVERRIDE_CDRCOENABLEPLL_bm = 0x20
    CLKGCNTOVERRIDE_CDRCOENABLEFD_bm = 0x10
    CLKGCNTOVERRIDE_CDRCOENABLECDR_bm = 0x08
    CLKGCNTOVERRIDE_CDRCODISDATACOUNTERREF_bm = 0x04
    CLKGCNTOVERRIDE_CDRCODISDESVBIASGEN_bm = 0x02
    CLKGCNTOVERRIDE_CDRCOCONNECTPLL_bm = 0x01
    CLKGOVERRIDECAPBANK = 0x002b
    CLKGOVERRIDECAPBANK_CLKGCAPBANKSELECT_of = 0
    CLKGWAITTIME = 0x002c
    CLKGWAITTIME_CLKGWAITCDRTIME_of = 4
    CLKGWAITTIME_CLKGWAITPLLTIME_of = 0
    CLKGLFCONFIG0 = 0x002d
    CLKGLFCONFIG0_CLKGLOCKFILTERENABLE_bm = 0x80
    CLKGLFCONFIG0_CLKGCAPBANKSELECT8_bm = 0x10
    CLKGLFCONFIG0_CLKGLOCKFILTERLOCKTHRCOUNTER_of = 0
    CLKGLFCONFIG1 = 0x002e
    CLKGLFCONFIG1_CLKGLOCKFILTERRELOCKTHRCOUNTER_of = 4
    CLKGLFCONFIG1_CLKGLOCKFILTERUNLOCKTHRCOUNTER_of = 0
    FAMAXHEADERFOUNDCOUNT = 0x002f
    FAMAXHEADERFOUNDCOUNT_FAMAXHEADERFOUNDCOUNT_of = 0
    FAMAXHEADERFOUNDCOUNTAFTERNF = 0x0030
    FAMAXHEADERFOUNDCOUNTAFTERNF_FAMAXHEADERFOUNDCOUNTAFTERNF_of = 0
    FAMAXHEADERNOTFOUNDCOUNT = 0x0031
    FAMAXHEADERNOTFOUNDCOUNT_FAMAXHEADERNOTFOUNDCOUNT_of = 0
    FAFAMAXSKIPCYCLECOUNTAFTERNF = 0x0032
    FAFAMAXSKIPCYCLECOUNTAFTERNF_FAMAXSKIPCYCLECOUNTAFTERNF_of = 0
    PSDLLCONFIG = 0x0033
    PSDLLCONFIG_EPRXUNLOCKTHRESHOLD_of = 4
    PSDLLCONFIG_PSDLLCONFIRMCOUNT_of = 2
    PSDLLCONFIG_PSDLLCURRENTSEL_of = 0
    EPRXDLLCONFIG = 0x0034
    EPRXDLLCONFIG_EPRXDLLCURRENT_of = 6
    EPRXDLLCONFIG_EPRXDLLCONFIRMCOUNT_of = 4
    EPRXDLLCONFIG_EPRXDLLFSMCLKALWAYSON_bm = 0x08
    EPRXDLLCONFIG_EPRXDLLCOARSELOCKDETECTION_bm = 0x04
    EPRXDLLCONFIG_EPRXENABLEREINIT_bm = 0x02
    EPRXDLLCONFIG_EPRXDATAGATINGENABLE_bm = 0x01
    FORCEENABLE = 0x0035
    FORCEENABLE_FORCETXENABLE_bm = 0x80
    FORCEENABLE_FORCERXENABLE_bm = 0x40
    FORCEENABLE_LDFORCEENABLE_bm = 0x20
    FORCEENABLE_TESTCLKFORCEENABLE_bm = 0x10
    FORCEENABLE_I2CMCLKALWAYSENABLE_bm = 0x08
    FORCEENABLE_PSFSMCLKALWAYSON_bm = 0x04
    CHIPADR = 0x0036
    CHIPADR_HIGHSPEEDDATAOUTINVERT_bm = 0x80
    CHIPADR_HIGHSPEEDDATAININVERT_bm = 0x40
    CHIPADR_CHIPADDRESSBAR_of = 0
    EQCONFIG = 0x0037
    EQCONFIG_EQATTENUATION_of = 3
    EQCONFIG_EQCAP_of = 0
    EQRES = 0x0038
    EQRES_EQRES3_of = 6
    EQRES_EQRES2_of = 4
    EQRES_EQRES1_of = 2
    EQRES_EQRES0_of = 0
    LDCONFIGH = 0x0039
    LDCONFIGH_LDEMPHASISENABLE_bm = 0x80
    LDCONFIGH_LDMODULATIONCURRENT_of = 0
    LDCONFIGL = 0x003a
    LDCONFIGL_LDEMPHASISSHORT_bm = 0x80
    LDCONFIGL_LDEMPHASISAMP_of = 0
    REFCLK = 0x003b
    REFCLK_TESTCLKSETCM_bm = 0x10
    REFCLK_REFCLKFORCEENABLE_bm = 0x04
    REFCLK_REFCLKACBIAS_bm = 0x02
    REFCLK_REFCLKTERM_bm = 0x01
    SCCONFIG = 0x003c
    SCCONFIG_SCPARITYCHECKDISABLE_bm = 0x01
    RESETCONFIG = 0x003d
    RESETCONFIG_RESETOUTDRIVESTRENGTH_bm = 0x80
    RESETCONFIG_RESETOUTLENGTH_of = 5
    RESETCONFIG_BODENABLE_bm = 0x08
    RESETCONFIG_BODLEVEL_of = 0
    PGCONFIG = 0x003e
    PGCONFIG_PGENABLE_bm = 0x80
    PGCONFIG_PGLEVEL_of = 4
    PGCONFIG_PGDELAY_of = 0
    I2CMTRANSCONFIG = 0x003f
    I2CMTRANSCONFIG_I2CMTRANSENABLE_bm = 0x80
    I2CMTRANSCONFIG_I2CMTRANSCHANNEL_of = 5
    I2CMTRANSCONFIG_I2CMTRANSADDRESSEXT_of = 2
    I2CMTRANSADDRESS = 0x0040
    I2CMTRANSADDRESS_I2CMTRANSADDRESS_of = 0
    I2CMTRANSCTRL = 0x0041
    I2CMTRANSCTRL_I2CMTRANSCTRL_of = 0
    I2CMTRANSDATA0 = 0x0042
    I2CMTRANSDATA0_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA1 = 0x0043
    I2CMTRANSDATA1_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA2 = 0x0044
    I2CMTRANSDATA2_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA3 = 0x0045
    I2CMTRANSDATA3_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA4 = 0x0046
    I2CMTRANSDATA4_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA5 = 0x0047
    I2CMTRANSDATA5_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA6 = 0x0048
    I2CMTRANSDATA6_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA7 = 0x0049
    I2CMTRANSDATA7_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA8 = 0x004a
    I2CMTRANSDATA8_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA9 = 0x004b
    I2CMTRANSDATA9_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA10 = 0x004c
    I2CMTRANSDATA10_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA11 = 0x004d
    I2CMTRANSDATA11_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA12 = 0x004e
    I2CMTRANSDATA12_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA13 = 0x004f
    I2CMTRANSDATA13_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA14 = 0x0050
    I2CMTRANSDATA14_I2CMTRANSDATA_of = 0
    I2CMTRANSDATA15 = 0x0051
    I2CMTRANSDATA15_I2CMTRANSDATA_of = 0
    PIODIRH = 0x0052
    PIODIRH_PIODIR_of = 0
    PIODIRL = 0x0053
    PIODIRL_PIODIR_of = 0
    PIOOUTH = 0x0054
    PIOOUTH_PIOOUT_of = 0
    PIOOUTL = 0x0055
    PIOOUTL_PIOOUT_of = 0
    PIOPULLENAH = 0x0056
    PIOPULLENAH_PIOPULLENABLE_of = 0
    PIOPULLENAL = 0x0057
    PIOPULLENAL_PIOPULLENABLE_of = 0
    PIOUPDOWNH = 0x0058
    PIOUPDOWNH_PIOUPDOWN_of = 0
    PIOUPDOWNL = 0x0059
    PIOUPDOWNL_PIOUPDOWN_of = 0
    PIODRIVESTRENGTHH = 0x005a
    PIODRIVESTRENGTHH_PIODRIVESTRENGTH_of = 0
    PIODRIVESTRENGTHL = 0x005b
    PIODRIVESTRENGTHL_PIODRIVESTRENGTH_of = 0
    PS0CONFIG = 0x005c
    PS0CONFIG_PS0DELAY8_bm = 0x80
    PS0CONFIG_PS0ENABLEFINETUNE_bm = 0x40
    PS0CONFIG_PS0DRIVESTRENGTH_of = 3
    PS0CONFIG_PS0FREQ_of = 0
    PS0DELAY = 0x005d
    PS0DELAY_PS0DELAY_of = 0
    PS0OUTDRIVER = 0x005e
    PS0OUTDRIVER_PS0PREEMPHASISSTRENGTH_of = 5
    PS0OUTDRIVER_PS0PREEMPHASISMODE_of = 3
    PS0OUTDRIVER_PS0PREEMPHASISWIDTH_of = 0
    PS1CONFIG = 0x005f
    PS1CONFIG_PS1DELAY8_bm = 0x80
    PS1CONFIG_PS1ENABLEFINETUNE_bm = 0x40
    PS1CONFIG_PS1DRIVESTRENGTH_of = 3
    PS1CONFIG_PS1FREQ_of = 0
    PS1DELAY = 0x0060
    PS1DELAY_PS1DELAY_of = 0
    PS1OUTDRIVER = 0x0061
    PS1OUTDRIVER_PS1PREEMPHASISSTRENGTH_of = 5
    PS1OUTDRIVER_PS1PREEMPHASISMODE_of = 3
    PS1OUTDRIVER_PS1PREEMPHASISWIDTH_of = 0
    PS2CONFIG = 0x0062
    PS2CONFIG_PS2DELAY8_bm = 0x80
    PS2CONFIG_PS2ENABLEFINETUNE_bm = 0x40
    PS2CONFIG_PS2DRIVESTRENGTH_of = 3
    PS2CONFIG_PS2FREQ_of = 0
    PS2DELAY = 0x0063
    PS2DELAY_PS2DELAY_of = 0
    PS2OUTDRIVER = 0x0064
    PS2OUTDRIVER_PS2PREEMPHASISSTRENGTH_of = 5
    PS2OUTDRIVER_PS2PREEMPHASISMODE_of = 3
    PS2OUTDRIVER_PS2PREEMPHASISWIDTH_of = 0
    PS3CONFIG = 0x0065
    PS3CONFIG_PS3DELAY8_bm = 0x80
    PS3CONFIG_PS3ENABLEFINETUNE_bm = 0x40
    PS3CONFIG_PS3DRIVESTRENGTH_of = 3
    PS3CONFIG_PS3FREQ_of = 0
    PS3DELAY = 0x0066
    PS3DELAY_PS3DELAY_of = 0
    PS3OUTDRIVER = 0x0067
    PS3OUTDRIVER_PS3PREEMPHASISSTRENGTH_of = 5
    PS3OUTDRIVER_PS3PREEMPHASISMODE_of = 3
    PS3OUTDRIVER_PS3PREEMPHASISWIDTH_of = 0
    DACCONFIGH = 0x0068
    DACCONFIGH_VOLDACENABLE_bm = 0x80
    DACCONFIGH_CURDACENABLE_bm = 0x40
    DACCONFIGH_VOLDACVALUE_of = 0
    DACCONFIGL = 0x0069
    DACCONFIGL_VOLDACVALUE_of = 0
    CURDACVALUE = 0x006a
    CURDACVALUE_CURDACSELECT_of = 0
    CURDACCHN = 0x006b
    CURDACCHN_CURDACCHNENABLE_of = 0
    EPCLK0CHNCNTRH = 0x006c
    EPCLK0CHNCNTRH_EPCLK0INVERT_bm = 0x40
    EPCLK0CHNCNTRH_EPCLK0DRIVESTRENGTH_of = 3
    EPCLK0CHNCNTRH_EPCLK0FREQ_of = 0
    EPCLK0CHNCNTRL = 0x006d
    EPCLK0CHNCNTRL_EPCLK0PREEMPHASISSTRENGTH_of = 5
    EPCLK0CHNCNTRL_EPCLK0PREEMPHASISMODE_of = 3
    EPCLK0CHNCNTRL_EPCLK0PREEMPHASISWIDTH_of = 0
    EPCLK1CHNCNTRH = 0x006e
    EPCLK1CHNCNTRH_EPCLK1INVERT_bm = 0x40
    EPCLK1CHNCNTRH_EPCLK1DRIVESTRENGTH_of = 3
    EPCLK1CHNCNTRH_EPCLK1FREQ_of = 0
    EPCLK1CHNCNTRL = 0x006f
    EPCLK1CHNCNTRL_EPCLK1PREEMPHASISSTRENGTH_of = 5
    EPCLK1CHNCNTRL_EPCLK1PREEMPHASISMODE_of = 3
    EPCLK1CHNCNTRL_EPCLK1PREEMPHASISWIDTH_of = 0
    EPCLK2CHNCNTRH = 0x0070
    EPCLK2CHNCNTRH_EPCLK2INVERT_bm = 0x40
    EPCLK2CHNCNTRH_EPCLK2DRIVESTRENGTH_of = 3
    EPCLK2CHNCNTRH_EPCLK2FREQ_of = 0
    EPCLK2CHNCNTRL = 0x0071
    EPCLK2CHNCNTRL_EPCLK2PREEMPHASISSTRENGTH_of = 5
    EPCLK2CHNCNTRL_EPCLK2PREEMPHASISMODE_of = 3
    EPCLK2CHNCNTRL_EPCLK2PREEMPHASISWIDTH_of = 0
    EPCLK3CHNCNTRH = 0x0072
    EPCLK3CHNCNTRH_EPCLK3INVERT_bm = 0x40
    EPCLK3CHNCNTRH_EPCLK3DRIVESTRENGTH_of = 3
    EPCLK3CHNCNTRH_EPCLK3FREQ_of = 0
    EPCLK3CHNCNTRL = 0x0073
    EPCLK3CHNCNTRL_EPCLK3PREEMPHASISSTRENGTH_of = 5
    EPCLK3CHNCNTRL_EPCLK3PREEMPHASISMODE_of = 3
    EPCLK3CHNCNTRL_EPCLK3PREEMPHASISWIDTH_of = 0
    EPCLK4CHNCNTRH = 0x0074
    EPCLK4CHNCNTRH_EPCLK4INVERT_bm = 0x40
    EPCLK4CHNCNTRH_EPCLK4DRIVESTRENGTH_of = 3
    EPCLK4CHNCNTRH_EPCLK4FREQ_of = 0
    EPCLK4CHNCNTRL = 0x0075
    EPCLK4CHNCNTRL_EPCLK4PREEMPHASISSTRENGTH_of = 5
    EPCLK4CHNCNTRL_EPCLK4PREEMPHASISMODE_of = 3
    EPCLK4CHNCNTRL_EPCLK4PREEMPHASISWIDTH_of = 0
    EPCLK5CHNCNTRH = 0x0076
    EPCLK5CHNCNTRH_EPCLK5INVERT_bm = 0x40
    EPCLK5CHNCNTRH_EPCLK5DRIVESTRENGTH_of = 3
    EPCLK5CHNCNTRH_EPCLK5FREQ_of = 0
    EPCLK5CHNCNTRL = 0x0077
    EPCLK5CHNCNTRL_EPCLK5PREEMPHASISSTRENGTH_of = 5
    EPCLK5CHNCNTRL_EPCLK5PREEMPHASISMODE_of = 3
    EPCLK5CHNCNTRL_EPCLK5PREEMPHASISWIDTH_of = 0
    EPCLK6CHNCNTRH = 0x0078
    EPCLK6CHNCNTRH_EPCLK6INVERT_bm = 0x40
    EPCLK6CHNCNTRH_EPCLK6DRIVESTRENGTH_of = 3
    EPCLK6CHNCNTRH_EPCLK6FREQ_of = 0
    EPCLK6CHNCNTRL = 0x0079
    EPCLK6CHNCNTRL_EPCLK6PREEMPHASISSTRENGTH_of = 5
    EPCLK6CHNCNTRL_EPCLK6PREEMPHASISMODE_of = 3
    EPCLK6CHNCNTRL_EPCLK6PREEMPHASISWIDTH_of = 0
    EPCLK7CHNCNTRH = 0x007a
    EPCLK7CHNCNTRH_EPCLK7INVERT_bm = 0x40
    EPCLK7CHNCNTRH_EPCLK7DRIVESTRENGTH_of = 3
    EPCLK7CHNCNTRH_EPCLK7FREQ_of = 0
    EPCLK7CHNCNTRL = 0x007b
    EPCLK7CHNCNTRL_EPCLK7PREEMPHASISSTRENGTH_of = 5
    EPCLK7CHNCNTRL_EPCLK7PREEMPHASISMODE_of = 3
    EPCLK7CHNCNTRL_EPCLK7PREEMPHASISWIDTH_of = 0
    EPCLK8CHNCNTRH = 0x007c
    EPCLK8CHNCNTRH_EPCLK8INVERT_bm = 0x40
    EPCLK8CHNCNTRH_EPCLK8DRIVESTRENGTH_of = 3
    EPCLK8CHNCNTRH_EPCLK8FREQ_of = 0
    EPCLK8CHNCNTRL = 0x007d
    EPCLK8CHNCNTRL_EPCLK8PREEMPHASISSTRENGTH_of = 5
    EPCLK8CHNCNTRL_EPCLK8PREEMPHASISMODE_of = 3
    EPCLK8CHNCNTRL_EPCLK8PREEMPHASISWIDTH_of = 0
    EPCLK9CHNCNTRH = 0x007e
    EPCLK9CHNCNTRH_EPCLK9INVERT_bm = 0x40
    EPCLK9CHNCNTRH_EPCLK9DRIVESTRENGTH_of = 3
    EPCLK9CHNCNTRH_EPCLK9FREQ_of = 0
    EPCLK9CHNCNTRL = 0x007f
    EPCLK9CHNCNTRL_EPCLK9PREEMPHASISSTRENGTH_of = 5
    EPCLK9CHNCNTRL_EPCLK9PREEMPHASISMODE_of = 3
    EPCLK9CHNCNTRL_EPCLK9PREEMPHASISWIDTH_of = 0
    EPCLK10CHNCNTRH = 0x0080
    EPCLK10CHNCNTRH_EPCLK10INVERT_bm = 0x40
    EPCLK10CHNCNTRH_EPCLK10DRIVESTRENGTH_of = 3
    EPCLK10CHNCNTRH_EPCLK10FREQ_of = 0
    EPCLK10CHNCNTRL = 0x0081
    EPCLK10CHNCNTRL_EPCLK10PREEMPHASISSTRENGTH_of = 5
    EPCLK10CHNCNTRL_EPCLK10PREEMPHASISMODE_of = 3
    EPCLK10CHNCNTRL_EPCLK10PREEMPHASISWIDTH_of = 0
    EPCLK11CHNCNTRH = 0x0082
    EPCLK11CHNCNTRH_EPCLK11INVERT_bm = 0x40
    EPCLK11CHNCNTRH_EPCLK11DRIVESTRENGTH_of = 3
    EPCLK11CHNCNTRH_EPCLK11FREQ_of = 0
    EPCLK11CHNCNTRL = 0x0083
    EPCLK11CHNCNTRL_EPCLK11PREEMPHASISSTRENGTH_of = 5
    EPCLK11CHNCNTRL_EPCLK11PREEMPHASISMODE_of = 3
    EPCLK11CHNCNTRL_EPCLK11PREEMPHASISWIDTH_of = 0
    EPCLK12CHNCNTRH = 0x0084
    EPCLK12CHNCNTRH_EPCLK12INVERT_bm = 0x40
    EPCLK12CHNCNTRH_EPCLK12DRIVESTRENGTH_of = 3
    EPCLK12CHNCNTRH_EPCLK12FREQ_of = 0
    EPCLK12CHNCNTRL = 0x0085
    EPCLK12CHNCNTRL_EPCLK12PREEMPHASISSTRENGTH_of = 5
    EPCLK12CHNCNTRL_EPCLK12PREEMPHASISMODE_of = 3
    EPCLK12CHNCNTRL_EPCLK12PREEMPHASISWIDTH_of = 0
    EPCLK13CHNCNTRH = 0x0086
    EPCLK13CHNCNTRH_EPCLK13INVERT_bm = 0x40
    EPCLK13CHNCNTRH_EPCLK13DRIVESTRENGTH_of = 3
    EPCLK13CHNCNTRH_EPCLK13FREQ_of = 0
    EPCLK13CHNCNTRL = 0x0087
    EPCLK13CHNCNTRL_EPCLK13PREEMPHASISSTRENGTH_of = 5
    EPCLK13CHNCNTRL_EPCLK13PREEMPHASISMODE_of = 3
    EPCLK13CHNCNTRL_EPCLK13PREEMPHASISWIDTH_of = 0
    EPCLK14CHNCNTRH = 0x0088
    EPCLK14CHNCNTRH_EPCLK14INVERT_bm = 0x40
    EPCLK14CHNCNTRH_EPCLK14DRIVESTRENGTH_of = 3
    EPCLK14CHNCNTRH_EPCLK14FREQ_of = 0
    EPCLK14CHNCNTRL = 0x0089
    EPCLK14CHNCNTRL_EPCLK14PREEMPHASISSTRENGTH_of = 5
    EPCLK14CHNCNTRL_EPCLK14PREEMPHASISMODE_of = 3
    EPCLK14CHNCNTRL_EPCLK14PREEMPHASISWIDTH_of = 0
    EPCLK15CHNCNTRH = 0x008a
    EPCLK15CHNCNTRH_EPCLK15INVERT_bm = 0x40
    EPCLK15CHNCNTRH_EPCLK15DRIVESTRENGTH_of = 3
    EPCLK15CHNCNTRH_EPCLK15FREQ_of = 0
    EPCLK15CHNCNTRL = 0x008b
    EPCLK15CHNCNTRL_EPCLK15PREEMPHASISSTRENGTH_of = 5
    EPCLK15CHNCNTRL_EPCLK15PREEMPHASISMODE_of = 3
    EPCLK15CHNCNTRL_EPCLK15PREEMPHASISWIDTH_of = 0
    EPCLK16CHNCNTRH = 0x008c
    EPCLK16CHNCNTRH_EPCLK16INVERT_bm = 0x40
    EPCLK16CHNCNTRH_EPCLK16DRIVESTRENGTH_of = 3
    EPCLK16CHNCNTRH_EPCLK16FREQ_of = 0
    EPCLK16CHNCNTRL = 0x008d
    EPCLK16CHNCNTRL_EPCLK16PREEMPHASISSTRENGTH_of = 5
    EPCLK16CHNCNTRL_EPCLK16PREEMPHASISMODE_of = 3
    EPCLK16CHNCNTRL_EPCLK16PREEMPHASISWIDTH_of = 0
    EPCLK17CHNCNTRH = 0x008e
    EPCLK17CHNCNTRH_EPCLK17INVERT_bm = 0x40
    EPCLK17CHNCNTRH_EPCLK17DRIVESTRENGTH_of = 3
    EPCLK17CHNCNTRH_EPCLK17FREQ_of = 0
    EPCLK17CHNCNTRL = 0x008f
    EPCLK17CHNCNTRL_EPCLK17PREEMPHASISSTRENGTH_of = 5
    EPCLK17CHNCNTRL_EPCLK17PREEMPHASISMODE_of = 3
    EPCLK17CHNCNTRL_EPCLK17PREEMPHASISWIDTH_of = 0
    EPCLK18CHNCNTRH = 0x0090
    EPCLK18CHNCNTRH_EPCLK18INVERT_bm = 0x40
    EPCLK18CHNCNTRH_EPCLK18DRIVESTRENGTH_of = 3
    EPCLK18CHNCNTRH_EPCLK18FREQ_of = 0
    EPCLK18CHNCNTRL = 0x0091
    EPCLK18CHNCNTRL_EPCLK18PREEMPHASISSTRENGTH_of = 5
    EPCLK18CHNCNTRL_EPCLK18PREEMPHASISMODE_of = 3
    EPCLK18CHNCNTRL_EPCLK18PREEMPHASISWIDTH_of = 0
    EPCLK19CHNCNTRH = 0x0092
    EPCLK19CHNCNTRH_EPCLK19INVERT_bm = 0x40
    EPCLK19CHNCNTRH_EPCLK19DRIVESTRENGTH_of = 3
    EPCLK19CHNCNTRH_EPCLK19FREQ_of = 0
    EPCLK19CHNCNTRL = 0x0093
    EPCLK19CHNCNTRL_EPCLK19PREEMPHASISSTRENGTH_of = 5
    EPCLK19CHNCNTRL_EPCLK19PREEMPHASISMODE_of = 3
    EPCLK19CHNCNTRL_EPCLK19PREEMPHASISWIDTH_of = 0
    EPCLK20CHNCNTRH = 0x0094
    EPCLK20CHNCNTRH_EPCLK20INVERT_bm = 0x40
    EPCLK20CHNCNTRH_EPCLK20DRIVESTRENGTH_of = 3
    EPCLK20CHNCNTRH_EPCLK20FREQ_of = 0
    EPCLK20CHNCNTRL = 0x0095
    EPCLK20CHNCNTRL_EPCLK20PREEMPHASISSTRENGTH_of = 5
    EPCLK20CHNCNTRL_EPCLK20PREEMPHASISMODE_of = 3
    EPCLK20CHNCNTRL_EPCLK20PREEMPHASISWIDTH_of = 0
    EPCLK21CHNCNTRH = 0x0096
    EPCLK21CHNCNTRH_EPCLK21INVERT_bm = 0x40
    EPCLK21CHNCNTRH_EPCLK21DRIVESTRENGTH_of = 3
    EPCLK21CHNCNTRH_EPCLK21FREQ_of = 0
    EPCLK21CHNCNTRL = 0x0097
    EPCLK21CHNCNTRL_EPCLK21PREEMPHASISSTRENGTH_of = 5
    EPCLK21CHNCNTRL_EPCLK21PREEMPHASISMODE_of = 3
    EPCLK21CHNCNTRL_EPCLK21PREEMPHASISWIDTH_of = 0
    EPCLK22CHNCNTRH = 0x0098
    EPCLK22CHNCNTRH_EPCLK22INVERT_bm = 0x40
    EPCLK22CHNCNTRH_EPCLK22DRIVESTRENGTH_of = 3
    EPCLK22CHNCNTRH_EPCLK22FREQ_of = 0
    EPCLK22CHNCNTRL = 0x0099
    EPCLK22CHNCNTRL_EPCLK22PREEMPHASISSTRENGTH_of = 5
    EPCLK22CHNCNTRL_EPCLK22PREEMPHASISMODE_of = 3
    EPCLK22CHNCNTRL_EPCLK22PREEMPHASISWIDTH_of = 0
    EPCLK23CHNCNTRH = 0x009a
    EPCLK23CHNCNTRH_EPCLK23INVERT_bm = 0x40
    EPCLK23CHNCNTRH_EPCLK23DRIVESTRENGTH_of = 3
    EPCLK23CHNCNTRH_EPCLK23FREQ_of = 0
    EPCLK23CHNCNTRL = 0x009b
    EPCLK23CHNCNTRL_EPCLK23PREEMPHASISSTRENGTH_of = 5
    EPCLK23CHNCNTRL_EPCLK23PREEMPHASISMODE_of = 3
    EPCLK23CHNCNTRL_EPCLK23PREEMPHASISWIDTH_of = 0
    EPCLK24CHNCNTRH = 0x009c
    EPCLK24CHNCNTRH_EPCLK24INVERT_bm = 0x40
    EPCLK24CHNCNTRH_EPCLK24DRIVESTRENGTH_of = 3
    EPCLK24CHNCNTRH_EPCLK24FREQ_of = 0
    EPCLK24CHNCNTRL = 0x009d
    EPCLK24CHNCNTRL_EPCLK24PREEMPHASISSTRENGTH_of = 5
    EPCLK24CHNCNTRL_EPCLK24PREEMPHASISMODE_of = 3
    EPCLK24CHNCNTRL_EPCLK24PREEMPHASISWIDTH_of = 0
    EPCLK25CHNCNTRH = 0x009e
    EPCLK25CHNCNTRH_EPCLK25INVERT_bm = 0x40
    EPCLK25CHNCNTRH_EPCLK25DRIVESTRENGTH_of = 3
    EPCLK25CHNCNTRH_EPCLK25FREQ_of = 0
    EPCLK25CHNCNTRL = 0x009f
    EPCLK25CHNCNTRL_EPCLK25PREEMPHASISSTRENGTH_of = 5
    EPCLK25CHNCNTRL_EPCLK25PREEMPHASISMODE_of = 3
    EPCLK25CHNCNTRL_EPCLK25PREEMPHASISWIDTH_of = 0
    EPCLK26CHNCNTRH = 0x00a0
    EPCLK26CHNCNTRH_EPCLK26INVERT_bm = 0x40
    EPCLK26CHNCNTRH_EPCLK26DRIVESTRENGTH_of = 3
    EPCLK26CHNCNTRH_EPCLK26FREQ_of = 0
    EPCLK26CHNCNTRL = 0x00a1
    EPCLK26CHNCNTRL_EPCLK26PREEMPHASISSTRENGTH_of = 5
    EPCLK26CHNCNTRL_EPCLK26PREEMPHASISMODE_of = 3
    EPCLK26CHNCNTRL_EPCLK26PREEMPHASISWIDTH_of = 0
    EPCLK27CHNCNTRH = 0x00a2
    EPCLK27CHNCNTRH_EPCLK27INVERT_bm = 0x40
    EPCLK27CHNCNTRH_EPCLK27DRIVESTRENGTH_of = 3
    EPCLK27CHNCNTRH_EPCLK27FREQ_of = 0
    EPCLK27CHNCNTRL = 0x00a3
    EPCLK27CHNCNTRL_EPCLK27PREEMPHASISSTRENGTH_of = 5
    EPCLK27CHNCNTRL_EPCLK27PREEMPHASISMODE_of = 3
    EPCLK27CHNCNTRL_EPCLK27PREEMPHASISWIDTH_of = 0
    EPCLK28CHNCNTRH = 0x00a4
    EPCLK28CHNCNTRH_EPCLK28INVERT_bm = 0x40
    EPCLK28CHNCNTRH_EPCLK28DRIVESTRENGTH_of = 3
    EPCLK28CHNCNTRH_EPCLK28FREQ_of = 0
    EPCLK28CHNCNTRL = 0x00a5
    EPCLK28CHNCNTRL_EPCLK28PREEMPHASISSTRENGTH_of = 5
    EPCLK28CHNCNTRL_EPCLK28PREEMPHASISMODE_of = 3
    EPCLK28CHNCNTRL_EPCLK28PREEMPHASISWIDTH_of = 0
    RESERVED1 = 0x00a6
    EPTXDATARATE = 0x00a7
    EPTXDATARATE_EPTX3DATARATE_of = 6
    EPTXDATARATE_EPTX2DATARATE_of = 4
    EPTXDATARATE_EPTX1DATARATE_of = 2
    EPTXDATARATE_EPTX0DATARATE_of = 0
    EPTXCONTROL = 0x00a8
    EPTXCONTROL_EPTXECPREEMPHASISWIDTH_of = 6
    EPTXCONTROL_EPTXECINVERT_bm = 0x20
    EPTXCONTROL_EPTXECENABLE_bm = 0x10
    EPTXCONTROL_EPTX3SHADOWENABLE_bm = 0x08
    EPTXCONTROL_EPTX2SHADOWENABLE_bm = 0x04
    EPTXCONTROL_EPTX1SHADOWENABLE_bm = 0x02
    EPTXCONTROL_EPTX0SHADOWENABLE_bm = 0x01
    EPTX10ENABLE = 0x00a9
    EPTX10ENABLE_EPTX13ENABLE_bm = 0x80
    EPTX10ENABLE_EPTX12ENABLE_bm = 0x40
    EPTX10ENABLE_EPTX11ENABLE_bm = 0x20
    EPTX10ENABLE_EPTX10ENABLE_bm = 0x10
    EPTX10ENABLE_EPTX03ENABLE_bm = 0x08
    EPTX10ENABLE_EPTX02ENABLE_bm = 0x04
    EPTX10ENABLE_EPTX01ENABLE_bm = 0x02
    EPTX10ENABLE_EPTX00ENABLE_bm = 0x01
    EPTX32ENABLE = 0x00aa
    EPTX32ENABLE_EPTX33ENABLE_bm = 0x80
    EPTX32ENABLE_EPTX32ENABLE_bm = 0x40
    EPTX32ENABLE_EPTX31ENABLE_bm = 0x20
    EPTX32ENABLE_EPTX30ENABLE_bm = 0x10
    EPTX32ENABLE_EPTX23ENABLE_bm = 0x08
    EPTX32ENABLE_EPTX22ENABLE_bm = 0x04
    EPTX32ENABLE_EPTX21ENABLE_bm = 0x02
    EPTX32ENABLE_EPTX20ENABLE_bm = 0x01
    EPTXECCHNCNTR = 0x00ab
    EPTXECCHNCNTR_EPTXECPREEMPHASISSTRENGTH_of = 5
    EPTXECCHNCNTR_EPTXECPREEMPHASISMODE_of = 3
    EPTXECCHNCNTR_EPTXECDRIVESTRENGTH_of = 0
    EPTX00CHNCNTR = 0x00ac
    EPTX00CHNCNTR_EPTX00PREEMPHASISSTRENGTH_of = 5
    EPTX00CHNCNTR_EPTX00PREEMPHASISMODE_of = 3
    EPTX00CHNCNTR_EPTX00DRIVESTRENGTH_of = 0
    EPTX01CHNCNTR = 0x00ad
    EPTX01CHNCNTR_EPTX01PREEMPHASISSTRENGTH_of = 5
    EPTX01CHNCNTR_EPTX01PREEMPHASISMODE_of = 3
    EPTX01CHNCNTR_EPTX01DRIVESTRENGTH_of = 0
    EPTX02CHNCNTR = 0x00ae
    EPTX02CHNCNTR_EPTX02PREEMPHASISSTRENGTH_of = 5
    EPTX02CHNCNTR_EPTX02PREEMPHASISMODE_of = 3
    EPTX02CHNCNTR_EPTX02DRIVESTRENGTH_of = 0
    EPTX03CHNCNTR = 0x00af
    EPTX03CHNCNTR_EPTX03PREEMPHASISSTRENGTH_of = 5
    EPTX03CHNCNTR_EPTX03PREEMPHASISMODE_of = 3
    EPTX03CHNCNTR_EPTX03DRIVESTRENGTH_of = 0
    EPTX10CHNCNTR = 0x00b0
    EPTX10CHNCNTR_EPTX10PREEMPHASISSTRENGTH_of = 5
    EPTX10CHNCNTR_EPTX10PREEMPHASISMODE_of = 3
    EPTX10CHNCNTR_EPTX10DRIVESTRENGTH_of = 0
    EPTX11CHNCNTR = 0x00b1
    EPTX11CHNCNTR_EPTX11PREEMPHASISSTRENGTH_of = 5
    EPTX11CHNCNTR_EPTX11PREEMPHASISMODE_of = 3
    EPTX11CHNCNTR_EPTX11DRIVESTRENGTH_of = 0
    EPTX12CHNCNTR = 0x00b2
    EPTX12CHNCNTR_EPTX12PREEMPHASISSTRENGTH_of = 5
    EPTX12CHNCNTR_EPTX12PREEMPHASISMODE_of = 3
    EPTX12CHNCNTR_EPTX12DRIVESTRENGTH_of = 0
    EPTX13CHNCNTR = 0x00b3
    EPTX13CHNCNTR_EPTX13PREEMPHASISSTRENGTH_of = 5
    EPTX13CHNCNTR_EPTX13PREEMPHASISMODE_of = 3
    EPTX13CHNCNTR_EPTX13DRIVESTRENGTH_of = 0
    EPTX20CHNCNTR = 0x00b4
    EPTX20CHNCNTR_EPTX20PREEMPHASISSTRENGTH_of = 5
    EPTX20CHNCNTR_EPTX20PREEMPHASISMODE_of = 3
    EPTX20CHNCNTR_EPTX20DRIVESTRENGTH_of = 0
    EPTX21CHNCNTR = 0x00b5
    EPTX21CHNCNTR_EPTX21PREEMPHASISSTRENGTH_of = 5
    EPTX21CHNCNTR_EPTX21PREEMPHASISMODE_of = 3
    EPTX21CHNCNTR_EPTX21DRIVESTRENGTH_of = 0
    EPTX22CHNCNTR = 0x00b6
    EPTX22CHNCNTR_EPTX22PREEMPHASISSTRENGTH_of = 5
    EPTX22CHNCNTR_EPTX22PREEMPHASISMODE_of = 3
    EPTX22CHNCNTR_EPTX22DRIVESTRENGTH_of = 0
    EPTX23CHNCNTR = 0x00b7
    EPTX23CHNCNTR_EPTX23PREEMPHASISSTRENGTH_of = 5
    EPTX23CHNCNTR_EPTX23PREEMPHASISMODE_of = 3
    EPTX23CHNCNTR_EPTX23DRIVESTRENGTH_of = 0
    EPTX30CHNCNTR = 0x00b8
    EPTX30CHNCNTR_EPTX30PREEMPHASISSTRENGTH_of = 5
    EPTX30CHNCNTR_EPTX30PREEMPHASISMODE_of = 3
    EPTX30CHNCNTR_EPTX30DRIVESTRENGTH_of = 0
    EPTX31CHNCNTR = 0x00b9
    EPTX31CHNCNTR_EPTX31PREEMPHASISSTRENGTH_of = 5
    EPTX31CHNCNTR_EPTX31PREEMPHASISMODE_of = 3
    EPTX31CHNCNTR_EPTX31DRIVESTRENGTH_of = 0
    EPTX32CHNCNTR = 0x00ba
    EPTX32CHNCNTR_EPTX32PREEMPHASISSTRENGTH_of = 5
    EPTX32CHNCNTR_EPTX32PREEMPHASISMODE_of = 3
    EPTX32CHNCNTR_EPTX32DRIVESTRENGTH_of = 0
    EPTX33CHNCNTR = 0x00bb
    EPTX33CHNCNTR_EPTX33PREEMPHASISSTRENGTH_of = 5
    EPTX33CHNCNTR_EPTX33PREEMPHASISMODE_of = 3
    EPTX33CHNCNTR_EPTX33DRIVESTRENGTH_of = 0
    EPTX01_00CHNCNTR = 0x00bc
    EPTX01_00CHNCNTR_EPTX01INVERT_bm = 0x80
    EPTX01_00CHNCNTR_EPTX01PREEMPHASISWIDTH_of = 4
    EPTX01_00CHNCNTR_EPTX00INVERT_bm = 0x08
    EPTX01_00CHNCNTR_EPTX00PREEMPHASISWIDTH_of = 0
    EPTX03_02CHNCNTR = 0x00bd
    EPTX03_02CHNCNTR_EPTX03INVERT_bm = 0x80
    EPTX03_02CHNCNTR_EPTX03PREEMPHASISWIDTH_of = 4
    EPTX03_02CHNCNTR_EPTX02INVERT_bm = 0x08
    EPTX03_02CHNCNTR_EPTX02PREEMPHASISWIDTH_of = 0
    EPTX11_10CHNCNTR = 0x00be
    EPTX11_10CHNCNTR_EPTX11INVERT_bm = 0x80
    EPTX11_10CHNCNTR_EPTX11PREEMPHASISWIDTH_of = 4
    EPTX11_10CHNCNTR_EPTX10INVERT_bm = 0x08
    EPTX11_10CHNCNTR_EPTX10PREEMPHASISWIDTH_of = 0
    EPTX13_12CHNCNTR = 0x00bf
    EPTX13_12CHNCNTR_EPTX13INVERT_bm = 0x80
    EPTX13_12CHNCNTR_EPTX13PREEMPHASISWIDTH_of = 4
    EPTX13_12CHNCNTR_EPTX12INVERT_bm = 0x08
    EPTX13_12CHNCNTR_EPTX12PREEMPHASISWIDTH_of = 0
    EPTX21_20CHNCNTR = 0x00c0
    EPTX21_20CHNCNTR_EPTX21INVERT_bm = 0x80
    EPTX21_20CHNCNTR_EPTX21PREEMPHASISWIDTH_of = 4
    EPTX21_20CHNCNTR_EPTX20INVERT_bm = 0x08
    EPTX21_20CHNCNTR_EPTX20PREEMPHASISWIDTH_of = 0
    EPTX23_22CHNCNTR = 0x00c1
    EPTX23_22CHNCNTR_EPTX23INVERT_bm = 0x80
    EPTX23_22CHNCNTR_EPTX23PREEMPHASISWIDTH_of = 4
    EPTX23_22CHNCNTR_EPTX22INVERT_bm = 0x08
    EPTX23_22CHNCNTR_EPTX22PREEMPHASISWIDTH_of = 0
    EPTX31_30CHNCNTR = 0x00c2
    EPTX31_30CHNCNTR_EPTX31INVERT_bm = 0x80
    EPTX31_30CHNCNTR_EPTX31PREEMPHASISWIDTH_of = 4
    EPTX31_30CHNCNTR_EPTX30INVERT_bm = 0x08
    EPTX31_30CHNCNTR_EPTX30PREEMPHASISWIDTH_of = 0
    EPTX33_32CHNCNTR = 0x00c3
    EPTX33_32CHNCNTR_EPTX33INVERT_bm = 0x80
    EPTX33_32CHNCNTR_EPTX33PREEMPHASISWIDTH_of = 4
    EPTX33_32CHNCNTR_EPTX32INVERT_bm = 0x08
    EPTX33_32CHNCNTR_EPTX32PREEMPHASISWIDTH_of = 0
    EPRX0CONTROL = 0x00c4
    EPRX0CONTROL_EPRX03ENABLE_bm = 0x80
    EPRX0CONTROL_EPRX02ENABLE_bm = 0x40
    EPRX0CONTROL_EPRX01ENABLE_bm = 0x20
    EPRX0CONTROL_EPRX00ENABLE_bm = 0x10
    EPRX0CONTROL_EPRX0DATARATE_of = 2
    EPRX0CONTROL_EPRX0TRACKMODE_of = 0
    EPRX1CONTROL = 0x00c5
    EPRX1CONTROL_EPRX13ENABLE_bm = 0x80
    EPRX1CONTROL_EPRX12ENABLE_bm = 0x40
    EPRX1CONTROL_EPRX11ENABLE_bm = 0x20
    EPRX1CONTROL_EPRX10ENABLE_bm = 0x10
    EPRX1CONTROL_EPRX1DATARATE_of = 2
    EPRX1CONTROL_EPRX1TRACKMODE_of = 0
    EPRX2CONTROL = 0x00c6
    EPRX2CONTROL_EPRX23ENABLE_bm = 0x80
    EPRX2CONTROL_EPRX22ENABLE_bm = 0x40
    EPRX2CONTROL_EPRX21ENABLE_bm = 0x20
    EPRX2CONTROL_EPRX20ENABLE_bm = 0x10
    EPRX2CONTROL_EPRX2DATARATE_of = 2
    EPRX2CONTROL_EPRX2TRACKMODE_of = 0
    EPRX3CONTROL = 0x00c7
    EPRX3CONTROL_EPRX33ENABLE_bm = 0x80
    EPRX3CONTROL_EPRX32ENABLE_bm = 0x40
    EPRX3CONTROL_EPRX31ENABLE_bm = 0x20
    EPRX3CONTROL_EPRX30ENABLE_bm = 0x10
    EPRX3CONTROL_EPRX3DATARATE_of = 2
    EPRX3CONTROL_EPRX3TRACKMODE_of = 0
    EPRX4CONTROL = 0x00c8
    EPRX4CONTROL_EPRX43ENABLE_bm = 0x80
    EPRX4CONTROL_EPRX42ENABLE_bm = 0x40
    EPRX4CONTROL_EPRX41ENABLE_bm = 0x20
    EPRX4CONTROL_EPRX40ENABLE_bm = 0x10
    EPRX4CONTROL_EPRX4DATARATE_of = 2
    EPRX4CONTROL_EPRX4TRACKMODE_of = 0
    EPRX5CONTROL = 0x00c9
    EPRX5CONTROL_EPRX53ENABLE_bm = 0x80
    EPRX5CONTROL_EPRX52ENABLE_bm = 0x40
    EPRX5CONTROL_EPRX51ENABLE_bm = 0x20
    EPRX5CONTROL_EPRX50ENABLE_bm = 0x10
    EPRX5CONTROL_EPRX5DATARATE_of = 2
    EPRX5CONTROL_EPRX5TRACKMODE_of = 0
    EPRX6CONTROL = 0x00ca
    EPRX6CONTROL_EPRX63ENABLE_bm = 0x80
    EPRX6CONTROL_EPRX62ENABLE_bm = 0x40
    EPRX6CONTROL_EPRX61ENABLE_bm = 0x20
    EPRX6CONTROL_EPRX60ENABLE_bm = 0x10
    EPRX6CONTROL_EPRX6DATARATE_of = 2
    EPRX6CONTROL_EPRX6TRACKMODE_of = 0
    EPRXECCONTROL = 0x00cb
    EPRXECCONTROL_EPRXECTRACKMODE_of = 0
    EPRX00CHNCNTR = 0x00cc
    EPRX00CHNCNTR_EPRX00PHASESELECT_of = 4
    EPRX00CHNCNTR_EPRX00INVERT_bm = 0x08
    EPRX00CHNCNTR_EPRX00ACBIAS_bm = 0x04
    EPRX00CHNCNTR_EPRX00TERM_bm = 0x02
    EPRX00CHNCNTR_EPRX00EQ1_bm = 0x01
    EPRX01CHNCNTR = 0x00cd
    EPRX01CHNCNTR_EPRX01PHASESELECT_of = 4
    EPRX01CHNCNTR_EPRX01INVERT_bm = 0x08
    EPRX01CHNCNTR_EPRX01ACBIAS_bm = 0x04
    EPRX01CHNCNTR_EPRX01TERM_bm = 0x02
    EPRX01CHNCNTR_EPRX01EQ1_bm = 0x01
    EPRX02CHNCNTR = 0x00ce
    EPRX02CHNCNTR_EPRX02PHASESELECT_of = 4
    EPRX02CHNCNTR_EPRX02INVERT_bm = 0x08
    EPRX02CHNCNTR_EPRX02ACBIAS_bm = 0x04
    EPRX02CHNCNTR_EPRX02TERM_bm = 0x02
    EPRX02CHNCNTR_EPRX02EQ1_bm = 0x01
    EPRX03CHNCNTR = 0x00cf
    EPRX03CHNCNTR_EPRX03PHASESELECT_of = 4
    EPRX03CHNCNTR_EPRX03INVERT_bm = 0x08
    EPRX03CHNCNTR_EPRX03ACBIAS_bm = 0x04
    EPRX03CHNCNTR_EPRX03TERM_bm = 0x02
    EPRX03CHNCNTR_EPRX03EQ1_bm = 0x01
    EPRX10CHNCNTR = 0x00d0
    EPRX10CHNCNTR_EPRX10PHASESELECT_of = 4
    EPRX10CHNCNTR_EPRX10INVERT_bm = 0x08
    EPRX10CHNCNTR_EPRX10ACBIAS_bm = 0x04
    EPRX10CHNCNTR_EPRX10TERM_bm = 0x02
    EPRX10CHNCNTR_EPRX10EQ1_bm = 0x01
    EPRX11CHNCNTR = 0x00d1
    EPRX11CHNCNTR_EPRX11PHASESELECT_of = 4
    EPRX11CHNCNTR_EPRX11INVERT_bm = 0x08
    EPRX11CHNCNTR_EPRX11ACBIAS_bm = 0x04
    EPRX11CHNCNTR_EPRX11TERM_bm = 0x02
    EPRX11CHNCNTR_EPRX11EQ1_bm = 0x01
    EPRX12CHNCNTR = 0x00d2
    EPRX12CHNCNTR_EPRX12PHASESELECT_of = 4
    EPRX12CHNCNTR_EPRX12INVERT_bm = 0x08
    EPRX12CHNCNTR_EPRX12ACBIAS_bm = 0x04
    EPRX12CHNCNTR_EPRX12TERM_bm = 0x02
    EPRX12CHNCNTR_EPRX12EQ1_bm = 0x01
    EPRX13CHNCNTR = 0x00d3
    EPRX13CHNCNTR_EPRX13PHASESELECT_of = 4
    EPRX13CHNCNTR_EPRX13INVERT_bm = 0x08
    EPRX13CHNCNTR_EPRX13ACBIAS_bm = 0x04
    EPRX13CHNCNTR_EPRX13TERM_bm = 0x02
    EPRX13CHNCNTR_EPRX13EQ1_bm = 0x01
    EPRX20CHNCNTR = 0x00d4
    EPRX20CHNCNTR_EPRX20PHASESELECT_of = 4
    EPRX20CHNCNTR_EPRX20INVERT_bm = 0x08
    EPRX20CHNCNTR_EPRX20ACBIAS_bm = 0x04
    EPRX20CHNCNTR_EPRX20TERM_bm = 0x02
    EPRX20CHNCNTR_EPRX20EQ1_bm = 0x01
    EPRX21CHNCNTR = 0x00d5
    EPRX21CHNCNTR_EPRX21PHASESELECT_of = 4
    EPRX21CHNCNTR_EPRX21INVERT_bm = 0x08
    EPRX21CHNCNTR_EPRX21ACBIAS_bm = 0x04
    EPRX21CHNCNTR_EPRX21TERM_bm = 0x02
    EPRX21CHNCNTR_EPRX21EQ1_bm = 0x01
    EPRX22CHNCNTR = 0x00d6
    EPRX22CHNCNTR_EPRX22PHASESELECT_of = 4
    EPRX22CHNCNTR_EPRX22INVERT_bm = 0x08
    EPRX22CHNCNTR_EPRX22ACBIAS_bm = 0x04
    EPRX22CHNCNTR_EPRX22TERM_bm = 0x02
    EPRX22CHNCNTR_EPRX22EQ1_bm = 0x01
    EPRX23CHNCNTR = 0x00d7
    EPRX23CHNCNTR_EPRX23PHASESELECT_of = 4
    EPRX23CHNCNTR_EPRX23INVERT_bm = 0x08
    EPRX23CHNCNTR_EPRX23ACBIAS_bm = 0x04
    EPRX23CHNCNTR_EPRX23TERM_bm = 0x02
    EPRX23CHNCNTR_EPRX23EQ1_bm = 0x01
    EPRX30CHNCNTR = 0x00d8
    EPRX30CHNCNTR_EPRX30PHASESELECT_of = 4
    EPRX30CHNCNTR_EPRX30INVERT_bm = 0x08
    EPRX30CHNCNTR_EPRX30ACBIAS_bm = 0x04
    EPRX30CHNCNTR_EPRX30TERM_bm = 0x02
    EPRX30CHNCNTR_EPRX30EQ1_bm = 0x01
    EPRX31CHNCNTR = 0x00d9
    EPRX31CHNCNTR_EPRX31PHASESELECT_of = 4
    EPRX31CHNCNTR_EPRX31INVERT_bm = 0x08
    EPRX31CHNCNTR_EPRX31ACBIAS_bm = 0x04
    EPRX31CHNCNTR_EPRX31TERM_bm = 0x02
    EPRX31CHNCNTR_EPRX31EQ1_bm = 0x01
    EPRX32CHNCNTR = 0x00da
    EPRX32CHNCNTR_EPRX32PHASESELECT_of = 4
    EPRX32CHNCNTR_EPRX32INVERT_bm = 0x08
    EPRX32CHNCNTR_EPRX32ACBIAS_bm = 0x04
    EPRX32CHNCNTR_EPRX32TERM_bm = 0x02
    EPRX32CHNCNTR_EPRX32EQ1_bm = 0x01
    EPRX33CHNCNTR = 0x00db
    EPRX33CHNCNTR_EPRX33PHASESELECT_of = 4
    EPRX33CHNCNTR_EPRX33INVERT_bm = 0x08
    EPRX33CHNCNTR_EPRX33ACBIAS_bm = 0x04
    EPRX33CHNCNTR_EPRX33TERM_bm = 0x02
    EPRX33CHNCNTR_EPRX33EQ1_bm = 0x01
    EPRX40CHNCNTR = 0x00dc
    EPRX40CHNCNTR_EPRX40PHASESELECT_of = 4
    EPRX40CHNCNTR_EPRX40INVERT_bm = 0x08
    EPRX40CHNCNTR_EPRX40ACBIAS_bm = 0x04
    EPRX40CHNCNTR_EPRX40TERM_bm = 0x02
    EPRX40CHNCNTR_EPRX40EQ1_bm = 0x01
    EPRX41CHNCNTR = 0x00dd
    EPRX41CHNCNTR_EPRX41PHASESELECT_of = 4
    EPRX41CHNCNTR_EPRX41INVERT_bm = 0x08
    EPRX41CHNCNTR_EPRX41ACBIAS_bm = 0x04
    EPRX41CHNCNTR_EPRX41TERM_bm = 0x02
    EPRX41CHNCNTR_EPRX41EQ1_bm = 0x01
    EPRX42CHNCNTR = 0x00de
    EPRX42CHNCNTR_EPRX42PHASESELECT_of = 4
    EPRX42CHNCNTR_EPRX42INVERT_bm = 0x08
    EPRX42CHNCNTR_EPRX42ACBIAS_bm = 0x04
    EPRX42CHNCNTR_EPRX42TERM_bm = 0x02
    EPRX42CHNCNTR_EPRX42EQ1_bm = 0x01
    EPRX43CHNCNTR = 0x00df
    EPRX43CHNCNTR_EPRX43PHASESELECT_of = 4
    EPRX43CHNCNTR_EPRX43INVERT_bm = 0x08
    EPRX43CHNCNTR_EPRX43ACBIAS_bm = 0x04
    EPRX43CHNCNTR_EPRX43TERM_bm = 0x02
    EPRX43CHNCNTR_EPRX43EQ1_bm = 0x01
    EPRX50CHNCNTR = 0x00e0
    EPRX50CHNCNTR_EPRX50PHASESELECT_of = 4
    EPRX50CHNCNTR_EPRX50INVERT_bm = 0x08
    EPRX50CHNCNTR_EPRX50ACBIAS_bm = 0x04
    EPRX50CHNCNTR_EPRX50TERM_bm = 0x02
    EPRX50CHNCNTR_EPRX50EQ1_bm = 0x01
    EPRX51CHNCNTR = 0x00e1
    EPRX51CHNCNTR_EPRX51PHASESELECT_of = 4
    EPRX51CHNCNTR_EPRX51INVERT_bm = 0x08
    EPRX51CHNCNTR_EPRX51ACBIAS_bm = 0x04
    EPRX51CHNCNTR_EPRX51TERM_bm = 0x02
    EPRX51CHNCNTR_EPRX51EQ1_bm = 0x01
    EPRX52CHNCNTR = 0x00e2
    EPRX52CHNCNTR_EPRX52PHASESELECT_of = 4
    EPRX52CHNCNTR_EPRX52INVERT_bm = 0x08
    EPRX52CHNCNTR_EPRX52ACBIAS_bm = 0x04
    EPRX52CHNCNTR_EPRX52TERM_bm = 0x02
    EPRX52CHNCNTR_EPRX52EQ1_bm = 0x01
    EPRX53CHNCNTR = 0x00e3
    EPRX53CHNCNTR_EPRX53PHASESELECT_of = 4
    EPRX53CHNCNTR_EPRX53INVERT_bm = 0x08
    EPRX53CHNCNTR_EPRX53ACBIAS_bm = 0x04
    EPRX53CHNCNTR_EPRX53TERM_bm = 0x02
    EPRX53CHNCNTR_EPRX53EQ1_bm = 0x01
    EPRX60CHNCNTR = 0x00e4
    EPRX60CHNCNTR_EPRX60PHASESELECT_of = 4
    EPRX60CHNCNTR_EPRX60INVERT_bm = 0x08
    EPRX60CHNCNTR_EPRX60ACBIAS_bm = 0x04
    EPRX60CHNCNTR_EPRX60TERM_bm = 0x02
    EPRX60CHNCNTR_EPRX60EQ1_bm = 0x01
    EPRX61CHNCNTR = 0x00e5
    EPRX61CHNCNTR_EPRX61PHASESELECT_of = 4
    EPRX61CHNCNTR_EPRX61INVERT_bm = 0x08
    EPRX61CHNCNTR_EPRX61ACBIAS_bm = 0x04
    EPRX61CHNCNTR_EPRX61TERM_bm = 0x02
    EPRX61CHNCNTR_EPRX61EQ1_bm = 0x01
    EPRX62CHNCNTR = 0x00e6
    EPRX62CHNCNTR_EPRX62PHASESELECT_of = 4
    EPRX62CHNCNTR_EPRX62INVERT_bm = 0x08
    EPRX62CHNCNTR_EPRX62ACBIAS_bm = 0x04
    EPRX62CHNCNTR_EPRX62TERM_bm = 0x02
    EPRX62CHNCNTR_EPRX62EQ1_bm = 0x01
    EPRX63CHNCNTR = 0x00e7
    EPRX63CHNCNTR_EPRX63PHASESELECT_of = 4
    EPRX63CHNCNTR_EPRX63INVERT_bm = 0x08
    EPRX63CHNCNTR_EPRX63ACBIAS_bm = 0x04
    EPRX63CHNCNTR_EPRX63TERM_bm = 0x02
    EPRX63CHNCNTR_EPRX63EQ1_bm = 0x01
    EPRXECCHNCNTR = 0x00e8
    EPRXECCHNCNTR_EPRXECPHASESELECT_of = 4
    EPRXECCHNCNTR_EPRXECINVERT_bm = 0x08
    EPRXECCHNCNTR_EPRXECACBIAS_bm = 0x04
    EPRXECCHNCNTR_EPRXECTERM_bm = 0x02
    EPRXECCHNCNTR_EPRXECENABLE_bm = 0x01
    EPRXEQ10CONTROL = 0x00e9
    EPRXEQ10CONTROL_EPRX13EQ0_bm = 0x80
    EPRXEQ10CONTROL_EPRX12EQ0_bm = 0x40
    EPRXEQ10CONTROL_EPRX11EQ0_bm = 0x20
    EPRXEQ10CONTROL_EPRX10EQ0_bm = 0x10
    EPRXEQ10CONTROL_EPRX03EQ0_bm = 0x08
    EPRXEQ10CONTROL_EPRX02EQ0_bm = 0x04
    EPRXEQ10CONTROL_EPRX01EQ0_bm = 0x02
    EPRXEQ10CONTROL_EPRX00EQ0_bm = 0x01
    EPRXEQ32CONTROL = 0x00ea
    EPRXEQ32CONTROL_EPRX33EQ0_bm = 0x80
    EPRXEQ32CONTROL_EPRX32EQ0_bm = 0x40
    EPRXEQ32CONTROL_EPRX31EQ0_bm = 0x20
    EPRXEQ32CONTROL_EPRX30EQ0_bm = 0x10
    EPRXEQ32CONTROL_EPRX23EQ0_bm = 0x08
    EPRXEQ32CONTROL_EPRX22EQ0_bm = 0x04
    EPRXEQ32CONTROL_EPRX21EQ0_bm = 0x02
    EPRXEQ32CONTROL_EPRX20EQ0_bm = 0x01
    EPRXEQ54CONTROL = 0x00eb
    EPRXEQ54CONTROL_EPRX53EQ0_bm = 0x80
    EPRXEQ54CONTROL_EPRX52EQ0_bm = 0x40
    EPRXEQ54CONTROL_EPRX51EQ0_bm = 0x20
    EPRXEQ54CONTROL_EPRX50EQ0_bm = 0x10
    EPRXEQ54CONTROL_EPRX43EQ0_bm = 0x08
    EPRXEQ54CONTROL_EPRX42EQ0_bm = 0x04
    EPRXEQ54CONTROL_EPRX41EQ0_bm = 0x02
    EPRXEQ54CONTROL_EPRX40EQ0_bm = 0x01
    EPRXEQ6CONTROL = 0x00ec
    EPRXEQ6CONTROL_EPRX63EQ0_bm = 0x08
    EPRXEQ6CONTROL_EPRX62EQ0_bm = 0x04
    EPRXEQ6CONTROL_EPRX61EQ0_bm = 0x02
    EPRXEQ6CONTROL_EPRX60EQ0_bm = 0x01
    POWERUP0 = 0x00ed
    POWERUP0_PUSMPLLWDOGDISABLE_bm = 0x40
    POWERUP0_PUSMDLLWDOGDISABLE_bm = 0x20
    POWERUP0_PUSMREADYWHENCHNSLOCKED_bm = 0x10
    POWERUP0_PUSMPLLTIMEOUTCONFIG_of = 0
    POWERUP1 = 0x00ee
    POWERUP1_PUSMDLLTIMEOUTCONFIG_of = 4
    POWERUP1_PUSMCHANNELSTIMEOUTCONFIG_of = 0
    POWERUP2 = 0x00ef
    POWERUP2_DLLCONFIGDONE_bm = 0x04
    POWERUP2_PLLCONFIGDONE_bm = 0x02
    POWERUP2_UPDATEENABLE_bm = 0x01
    I2CM0CONFIG = 0x00f0
    I2CM0CONFIG_I2CM0SCLPULLUPENABLE_bm = 0x40
    I2CM0CONFIG_I2CM0SCLDRIVESTRENGTH_bm = 0x20
    I2CM0CONFIG_I2CM0SDAPULLUPENABLE_bm = 0x10
    I2CM0CONFIG_I2CM0SDADRIVESTRENGTH_bm = 0x08
    I2CM0CONFIG_I2CM0ADDRESSEXT_of = 0
    I2CM0ADDRESS = 0x00f1
    I2CM0ADDRESS_I2CM0ADDRESS_of = 0
    I2CM0DATA0 = 0x00f2
    I2CM0DATA0_I2CM0DATA_of = 0
    I2CM0DATA1 = 0x00f3
    I2CM0DATA1_I2CM0DATA_of = 0
    I2CM0DATA2 = 0x00f4
    I2CM0DATA2_I2CM0DATA_of = 0
    I2CM0DATA3 = 0x00f5
    I2CM0DATA3_I2CM0DATA_of = 0
    I2CM0CMD = 0x00f6
    I2CM0CMD_I2CM0CMD_of = 0
    I2CM1CONFIG = 0x00f7
    I2CM1CONFIG_I2CM1SCLPULLUPENABLE_bm = 0x40
    I2CM1CONFIG_I2CM1SCLDRIVESTRENGTH_bm = 0x20
    I2CM1CONFIG_I2CM1SDAPULLUPENABLE_bm = 0x10
    I2CM1CONFIG_I2CM1SDADRIVESTRENGTH_bm = 0x08
    I2CM1CONFIG_I2CM1ADDRESSEXT_of = 0
    I2CM1ADDRESS = 0x00f8
    I2CM1ADDRESS_I2CM1ADDRESS_of = 0
    I2CM1DATA0 = 0x00f9
    I2CM1DATA0_I2CM1DATA_of = 0
    I2CM1DATA1 = 0x00fa
    I2CM1DATA1_I2CM1DATA_of = 0
    I2CM1DATA2 = 0x00fb
    I2CM1DATA2_I2CM1DATA_of = 0
    I2CM1DATA3 = 0x00fc
    I2CM1DATA3_I2CM1DATA_of = 0
    I2CM1CMD = 0x00fd
    I2CM1CMD_I2CM1CMD_of = 0
    I2CM2CONFIG = 0x00fe
    I2CM2CONFIG_I2CM2SCLPULLUPENABLE_bm = 0x40
    I2CM2CONFIG_I2CM2SCLDRIVESTRENGTH_bm = 0x20
    I2CM2CONFIG_I2CM2SDAPULLUPENABLE_bm = 0x10
    I2CM2CONFIG_I2CM2SDADRIVESTRENGTH_bm = 0x08
    I2CM2CONFIG_I2CM2ADDRESSEXT_of = 0
    I2CM2ADDRESS = 0x00ff
    I2CM2ADDRESS_I2CM2ADDRESS_of = 0
    I2CM2DATA0 = 0x0100
    I2CM2DATA0_I2CM2DATA_of = 0
    I2CM2DATA1 = 0x0101
    I2CM2DATA1_I2CM2DATA_of = 0
    I2CM2DATA2 = 0x0102
    I2CM2DATA2_I2CM2DATA_of = 0
    I2CM2DATA3 = 0x0103
    I2CM2DATA3_I2CM2DATA_of = 0
    I2CM2CMD = 0x0104
    I2CM2CMD_I2CM2CMD_of = 0
    EPRXTRAIN10 = 0x0105
    EPRXTRAIN10_EPRX1TRAIN_of = 4
    EPRXTRAIN10_EPRX0TRAIN_of = 0
    EPRXTRAIN32 = 0x0106
    EPRXTRAIN32_EPRX3TRAIN_of = 4
    EPRXTRAIN32_EPRX2TRAIN_of = 0
    EPRXTRAIN54 = 0x0107
    EPRXTRAIN54_EPRX5TRAIN_of = 4
    EPRXTRAIN54_EPRX4TRAIN_of = 0
    EPRXTRAINEC6 = 0x0108
    EPRXTRAINEC6_EPRXECTRAIN_bm = 0x10
    EPRXTRAINEC6_EPRX6TRAIN_of = 0
    FUSECONTROL = 0x0109
    FUSECONTROL_FUSEBLOWPULSELENGTH_of = 4
    FUSECONTROL_FUSEREAD_bm = 0x02
    FUSECONTROL_FUSEBLOW_bm = 0x01
    FUSEBLOWDATAA = 0x010a
    FUSEBLOWDATAA_FUSEBLOWDATA_of = 0
    FUSEBLOWDATAB = 0x010b
    FUSEBLOWDATAB_FUSEBLOWDATA_of = 0
    FUSEBLOWDATAC = 0x010c
    FUSEBLOWDATAC_FUSEBLOWDATA_of = 0
    FUSEBLOWDATAD = 0x010d
    FUSEBLOWDATAD_FUSEBLOWDATA_of = 0
    FUSEBLOWADDH = 0x010e
    FUSEBLOWADDH_FUSEBLOWADDRESS_of = 0
    FUSEBLOWADDL = 0x010f
    FUSEBLOWADDL_FUSEBLOWADDRESS_of = 0
    FUSEMAGIC = 0x0110
    FUSEMAGIC_FUSEMAGICNUMBER_of = 0
    ADCSELECT = 0x0111
    ADCSELECT_ADCINPSELECT_of = 4
    ADCSELECT_ADCINNSELECT_of = 0
    ADCMON = 0x0112
    ADCMON_TEMPSENSRESET_bm = 0x20
    ADCMON_VDDMONENA_bm = 0x10
    ADCMON_VDDTXMONENA_bm = 0x08
    ADCMON_VDDRXMONENA_bm = 0x04
    ADCMON_VDDPSTMONENA_bm = 0x02
    ADCMON_VDDANMONENA_bm = 0x01
    ADCCONFIG = 0x0113
    ADCCONFIG_ADCCONVERT_bm = 0x80
    ADCCONFIG_ADCENABLE_bm = 0x04
    ADCCONFIG_ADCGAINSELECT_of = 0
    EOMCONFIGH = 0x0114
    EOMCONFIGH_EOMENDOFCOUNTSEL_of = 4
    EOMCONFIGH_EOMBYPASSPHASEINTERPOLATOR_bm = 0x04
    EOMCONFIGH_EOMSTART_bm = 0x02
    EOMCONFIGH_EOMENABLE_bm = 0x01
    EOMCONFIGL = 0x0115
    EOMCONFIGL_EOMPHASESEL_of = 0
    EOMVOFSEL = 0x0116
    EOMVOFSEL_EOMVOFSEL_of = 0
    PROCESSANDSEUMONITOR = 0x0117
    PROCESSANDSEUMONITOR_DLDPFECCOUNTERENABLE_bm = 0x10
    PROCESSANDSEUMONITOR_SEUENABLE_bm = 0x08
    PROCESSANDSEUMONITOR_PMCHANNEL_of = 1
    PROCESSANDSEUMONITOR_PMENABLE_bm = 0x01
    ULDATASOURCE0 = 0x0118
    ULDATASOURCE0_ULECDATASOURCE_of = 5
    ULDATASOURCE0_ULSERTESTPATTERN_of = 0
    ULDATASOURCE1 = 0x0119
    ULDATASOURCE1_LDDATASOURCE_of = 6
    ULDATASOURCE1_ULG1DATASOURCE_of = 3
    ULDATASOURCE1_ULG0DATASOURCE_of = 0
    ULDATASOURCE2 = 0x011a
    ULDATASOURCE2_ULG3DATASOURCE_of = 3
    ULDATASOURCE2_ULG2DATASOURCE_of = 0
    ULDATASOURCE3 = 0x011b
    ULDATASOURCE3_ULG5DATASOURCE_of = 3
    ULDATASOURCE3_ULG4DATASOURCE_of = 0
    ULDATASOURCE4 = 0x011c
    ULDATASOURCE4_DLECDATASOURCE_of = 6
    ULDATASOURCE4_ULICDATASOURCE_of = 3
    ULDATASOURCE4_ULG6DATASOURCE_of = 0
    ULDATASOURCE5 = 0x011d
    ULDATASOURCE5_DLG3DATASOURCE_of = 6
    ULDATASOURCE5_DLG2DATASOURCE_of = 4
    ULDATASOURCE5_DLG1DATASOURCE_of = 2
    ULDATASOURCE5_DLG0DATASOURCE_of = 0
    DPDATAPATTERN3 = 0x011e
    DPDATAPATTERN3_DPDATAPATTERN_of = 0
    DPDATAPATTERN2 = 0x011f
    DPDATAPATTERN2_DPDATAPATTERN_of = 0
    DPDATAPATTERN1 = 0x0120
    DPDATAPATTERN1_DPDATAPATTERN_of = 0
    DPDATAPATTERN0 = 0x0121
    DPDATAPATTERN0_DPDATAPATTERN_of = 0
    EPRXPRBS3 = 0x0122
    EPRXPRBS3_EPRXECPRBSENABLE_bm = 0x10
    EPRXPRBS3_EPRX63PRBSENABLE_bm = 0x08
    EPRXPRBS3_EPRX62PRBSENABLE_bm = 0x04
    EPRXPRBS3_EPRX61PRBSENABLE_bm = 0x02
    EPRXPRBS3_EPRX60PRBSENABLE_bm = 0x01
    EPRXPRBS2 = 0x0123
    EPRXPRBS2_EPRX53PRBSENABLE_bm = 0x80
    EPRXPRBS2_EPRX52PRBSENABLE_bm = 0x40
    EPRXPRBS2_EPRX51PRBSENABLE_bm = 0x20
    EPRXPRBS2_EPRX50PRBSENABLE_bm = 0x10
    EPRXPRBS2_EPRX43PRBSENABLE_bm = 0x08
    EPRXPRBS2_EPRX42PRBSENABLE_bm = 0x04
    EPRXPRBS2_EPRX41PRBSENABLE_bm = 0x02
    EPRXPRBS2_EPRX40PRBSENABLE_bm = 0x01
    EPRXPRBS1 = 0x0124
    EPRXPRBS1_EPRX33PRBSENABLE_bm = 0x80
    EPRXPRBS1_EPRX32PRBSENABLE_bm = 0x40
    EPRXPRBS1_EPRX31PRBSENABLE_bm = 0x20
    EPRXPRBS1_EPRX30PRBSENABLE_bm = 0x10
    EPRXPRBS1_EPRX23PRBSENABLE_bm = 0x08
    EPRXPRBS1_EPRX22PRBSENABLE_bm = 0x04
    EPRXPRBS1_EPRX21PRBSENABLE_bm = 0x02
    EPRXPRBS1_EPRX20PRBSENABLE_bm = 0x01
    EPRXPRBS0 = 0x0125
    EPRXPRBS0_EPRX13PRBSENABLE_bm = 0x80
    EPRXPRBS0_EPRX12PRBSENABLE_bm = 0x40
    EPRXPRBS0_EPRX11PRBSENABLE_bm = 0x20
    EPRXPRBS0_EPRX10PRBSENABLE_bm = 0x10
    EPRXPRBS0_EPRX03PRBSENABLE_bm = 0x08
    EPRXPRBS0_EPRX02PRBSENABLE_bm = 0x04
    EPRXPRBS0_EPRX01PRBSENABLE_bm = 0x02
    EPRXPRBS0_EPRX00PRBSENABLE_bm = 0x01
    BERTSOURCE = 0x0126
    BERTSOURCE_BERTSOURCE_of = 0
    BERTCONFIG = 0x0127
    BERTCONFIG_BERTMEASTIME_of = 4
    BERTCONFIG_SKIPDISABLE_bm = 0x02
    BERTCONFIG_BERTSTART_bm = 0x01
    BERTDATAPATTERN3 = 0x0128
    BERTDATAPATTERN3_BERTDATAPATTERN_of = 0
    BERTDATAPATTERN2 = 0x0129
    BERTDATAPATTERN2_BERTDATAPATTERN_of = 0
    BERTDATAPATTERN1 = 0x012a
    BERTDATAPATTERN1_BERTDATAPATTERN_of = 0
    BERTDATAPATTERN0 = 0x012b
    BERTDATAPATTERN0_BERTDATAPATTERN_of = 0
    RST0 = 0x012c
    RST0_RSTPLLDIGITAL_bm = 0x80
    RST0_RSTFUSES_bm = 0x40
    RST0_RSTCONFIG_bm = 0x20
    RST0_RSTRXLOGIC_bm = 0x10
    RST0_RSTTXLOGIC_bm = 0x08
    RST0_RSTI2CM0_bm = 0x04
    RST0_RSTI2CM1_bm = 0x02
    RST0_RSTI2CM2_bm = 0x01
    RST1 = 0x012d
    RST1_RSTFRAMEALIGNER_bm = 0x80
    RST1_RSTEPRX6DLL_bm = 0x40
    RST1_RSTEPRX5DLL_bm = 0x20
    RST1_RSTEPRX4DLL_bm = 0x10
    RST1_RSTEPRX3DLL_bm = 0x08
    RST1_RSTEPRX2DLL_bm = 0x04
    RST1_RSTEPRX1DLL_bm = 0x02
    RST1_RSTEPRX0DLL_bm = 0x01
    RST2 = 0x012e
    RST2_SKIPFORCE_bm = 0x80
    RST2_RESETOUTFORCEACTIVE_bm = 0x40
    RST2_RSTPS3DLL_bm = 0x08
    RST2_RSTPS2DLL_bm = 0x04
    RST2_RSTPS1DLL_bm = 0x02
    RST2_RSTPS0DLL_bm = 0x01
    POWERUP3 = 0x012f
    POWERUP3_PUSMFORCESTATE_bm = 0x80
    POWERUP3_PUSMSTATEFORCED_of = 0
    POWERUP4 = 0x0130
    POWERUP4_PUSMFORCEMAGIC_of = 0
    CLKTREE = 0x0131
    CLKTREE_CLKTREEMAGICNUMBER_of = 3
    CLKTREE_CLKTREECDISABLE_bm = 0x04
    CLKTREE_CLKTREEBDISABLE_bm = 0x02
    CLKTREE_CLKTREEADISABLE_bm = 0x01
    DATAPATH = 0x0132
    DATAPATH_DLDPBYPASDEINTERLEVEAR_bm = 0x80
    DATAPATH_DLDPBYPASFECDECODER_bm = 0x40
    DATAPATH_DLDPBYPASSDESCRAMBLER_bm = 0x20
    DATAPATH_DLDPFECERRCNTENA_bm = 0x10
    DATAPATH_ULDPBYPASSINTERLEAVER_bm = 0x04
    DATAPATH_ULDPBYPASSSCRAMBLER_bm = 0x02
    DATAPATH_ULDPBYPASSFECCODER_bm = 0x01
    TO0SEL = 0x0133
    TO0SEL_TO0SELECT_of = 0
    TO1SEL = 0x0134
    TO1SEL_TO1SELECT_of = 0
    TO2SEL = 0x0135
    TO2SEL_TO2SELECT_of = 0
    TO3SEL = 0x0136
    TO3SEL_TO3SELECT_of = 0
    TO4SEL = 0x0137
    TO4SEL_TO4SELECT_of = 0
    TO5SEL = 0x0138
    TO5SEL_TO5SELECT_of = 0
    TODRIVINGSTRENGTH = 0x0139
    TODRIVINGSTRENGTH_TO3DS_bm = 0x08
    TODRIVINGSTRENGTH_TO2DS_bm = 0x04
    TODRIVINGSTRENGTH_TO1DS_bm = 0x02
    TODRIVINGSTRENGTH_TO0DS_bm = 0x01
    TO4DRIVER = 0x013a
    TO4DRIVER_TO4PREEMPHASISSTRENGTH_of = 5
    TO4DRIVER_TO4PREEMPHASISMODE_of = 3
    TO4DRIVER_TO4DRIVESTRENGTH_of = 0
    TO5DRIVER = 0x013b
    TO5DRIVER_TO5PREEMPHASISSTRENGTH_of = 5
    TO5DRIVER_TO5PREEMPHASISMODE_of = 3
    TO5DRIVER_TO5DRIVESTRENGTH_of = 0
    TOPREEMP = 0x013c
    TOPREEMP_TO5INVERT_bm = 0x80
    TOPREEMP_TO5PREEMPHASISWIDTH_of = 4
    TOPREEMP_TO4INVERT_bm = 0x08
    TOPREEMP_TO4PREEMPHASISWIDTH_of = 0
    CONFIGPINS = 0x0140
    CONFIGPINS_LPGBTMODE_of = 4
    CONFIGPINS_CONFIGSELECT_bm = 0x08
    CONFIGPINS_VCOBYPASS_bm = 0x04
    CONFIGPINS_LOCKMODE_bm = 0x02
    CONFIGPINS_STATEOVERRIDE_bm = 0x01
    I2CSLAVEADDRESS = 0x0141
    I2CSLAVEADDRESS_ASICCONTROLADR_of = 0
    EPRX0LOCKED = 0x0142
    EPRX0LOCKED_EPRX0CHNLOCKED_of = 4
    EPRX0LOCKED_EPRX0STATE_of = 0
    EPRX0CURRENTPHASE10 = 0x0143
    EPRX0CURRENTPHASE10_EPRX0CURRENTPHASE1_of = 4
    EPRX0CURRENTPHASE10_EPRX0CURRENTPHASE0_of = 0
    EPRX0CURRENTPHASE32 = 0x0144
    EPRX0CURRENTPHASE32_EPRX0CURRENTPHASE3_of = 4
    EPRX0CURRENTPHASE32_EPRX0CURRENTPHASE2_of = 0
    EPRX1LOCKED = 0x0145
    EPRX1LOCKED_EPRX1CHNLOCKED_of = 4
    EPRX1LOCKED_EPRX1STATE_of = 0
    EPRX1CURRENTPHASE10 = 0x0146
    EPRX1CURRENTPHASE10_EPRX1CURRENTPHASE1_of = 4
    EPRX1CURRENTPHASE10_EPRX1CURRENTPHASE0_of = 0
    EPRX1CURRENTPHASE32 = 0x0147
    EPRX1CURRENTPHASE32_EPRX1CURRENTPHASE3_of = 4
    EPRX1CURRENTPHASE32_EPRX1CURRENTPHASE2_of = 0
    EPRX2LOCKED = 0x0148
    EPRX2LOCKED_EPRX2CHNLOCKED_of = 4
    EPRX2LOCKED_EPRX2STATE_of = 0
    EPRX2CURRENTPHASE10 = 0x0149
    EPRX2CURRENTPHASE10_EPRX2CURRENTPHASE1_of = 4
    EPRX2CURRENTPHASE10_EPRX2CURRENTPHASE0_of = 0
    EPRX2CURRENTPHASE32 = 0x014a
    EPRX2CURRENTPHASE32_EPRX2CURRENTPHASE3_of = 4
    EPRX2CURRENTPHASE32_EPRX2CURRENTPHASE2_of = 0
    EPRX3LOCKED = 0x014b
    EPRX3LOCKED_EPRX3CHNLOCKED_of = 4
    EPRX3LOCKED_EPRX3STATE_of = 0
    EPRX3CURRENTPHASE10 = 0x014c
    EPRX3CURRENTPHASE10_EPRX3CURRENTPHASE1_of = 4
    EPRX3CURRENTPHASE10_EPRX3CURRENTPHASE0_of = 0
    EPRX3CURRENTPHASE32 = 0x014d
    EPRX3CURRENTPHASE32_EPRX3CURRENTPHASE3_of = 4
    EPRX3CURRENTPHASE32_EPRX3CURRENTPHASE2_of = 0
    EPRX4LOCKED = 0x014e
    EPRX4LOCKED_EPRX4CHNLOCKED_of = 4
    EPRX4LOCKED_EPRX4STATE_of = 0
    EPRX4CURRENTPHASE10 = 0x014f
    EPRX4CURRENTPHASE10_EPRX4CURRENTPHASE1_of = 4
    EPRX4CURRENTPHASE10_EPRX4CURRENTPHASE0_of = 0
    EPRX4CURRENTPHASE32 = 0x0150
    EPRX4CURRENTPHASE32_EPRX4CURRENTPHASE3_of = 4
    EPRX4CURRENTPHASE32_EPRX4CURRENTPHASE2_of = 0
    EPRX5LOCKED = 0x0151
    EPRX5LOCKED_EPRX5CHNLOCKED_of = 4
    EPRX5LOCKED_EPRX5STATE_of = 0
    EPRX5CURRENTPHASE10 = 0x0152
    EPRX5CURRENTPHASE10_EPRX5CURRENTPHASE1_of = 4
    EPRX5CURRENTPHASE10_EPRX5CURRENTPHASE0_of = 0
    EPRX5CURRENTPHASE32 = 0x0153
    EPRX5CURRENTPHASE32_EPRX5CURRENTPHASE3_of = 4
    EPRX5CURRENTPHASE32_EPRX5CURRENTPHASE2_of = 0
    EPRX6LOCKED = 0x0154
    EPRX6LOCKED_EPRX6CHNLOCKED_of = 4
    EPRX6LOCKED_EPRX6STATE_of = 0
    EPRX6CURRENTPHASE10 = 0x0155
    EPRX6CURRENTPHASE10_EPRX6CURRENTPHASE1_of = 4
    EPRX6CURRENTPHASE10_EPRX6CURRENTPHASE0_of = 0
    EPRX6CURRENTPHASE32 = 0x0156
    EPRX6CURRENTPHASE32_EPRX6CURRENTPHASE3_of = 4
    EPRX6CURRENTPHASE32_EPRX6CURRENTPHASE2_of = 0
    EPRXECCURRENTPHASE = 0x0157
    EPRXECCURRENTPHASE_EPRXECCURRENTPHASE_of = 0
    EPRX0DLLSTATUS = 0x0158
    EPRX0DLLSTATUS_EPRX0DLLLOCKED_bm = 0x80
    EPRX0DLLSTATUS_EPRX0DLLLFSTATE_of = 5
    EPRX0DLLSTATUS_EPRX0DLLLOLCNT_of = 0
    EPRX1DLLSTATUS = 0x0159
    EPRX1DLLSTATUS_EPRX1DLLLOCKED_bm = 0x80
    EPRX1DLLSTATUS_EPRX1DLLLFSTATE_of = 5
    EPRX1DLLSTATUS_EPRX1DLLLOLCNT_of = 0
    EPRX2DLLSTATUS = 0x015a
    EPRX2DLLSTATUS_EPRX2DLLLOCKED_bm = 0x80
    EPRX2DLLSTATUS_EPRX2DLLLFSTATE_of = 5
    EPRX2DLLSTATUS_EPRX2DLLLOLCNT_of = 0
    EPRX3DLLSTATUS = 0x015b
    EPRX3DLLSTATUS_EPRX3DLLLOCKED_bm = 0x80
    EPRX3DLLSTATUS_EPRX3DLLLFSTATE_of = 5
    EPRX3DLLSTATUS_EPRX3DLLLOLCNT_of = 0
    EPRX4DLLSTATUS = 0x015c
    EPRX4DLLSTATUS_EPRX4DLLLOCKED_bm = 0x80
    EPRX4DLLSTATUS_EPRX4DLLLFSTATE_of = 5
    EPRX4DLLSTATUS_EPRX4DLLLOLCNT_of = 0
    EPRX5DLLSTATUS = 0x015d
    EPRX5DLLSTATUS_EPRX5DLLLOCKED_bm = 0x80
    EPRX5DLLSTATUS_EPRX5DLLLFSTATE_of = 5
    EPRX5DLLSTATUS_EPRX5DLLLOLCNT_of = 0
    EPRX6DLLSTATUS = 0x015e
    EPRX6DLLSTATUS_EPRX6DLLLOCKED_bm = 0x80
    EPRX6DLLSTATUS_EPRX6DLLLFSTATE_of = 5
    EPRX6DLLSTATUS_EPRX6DLLLOLCNT_of = 0
    I2CM0CTRL = 0x015f
    I2CM0CTRL_I2CM0CTRL_of = 0
    I2CM0MASK = 0x0160
    I2CM0MASK_I2CM0MASK_of = 0
    I2CM0STATUS = 0x0161
    I2CM0STATUS_I2CM0STATUS_of = 0
    I2CM0TRANCNT = 0x0162
    I2CM0TRANCNT_I2CM0TRANCNT_of = 0
    I2CM0READBYTE = 0x0163
    I2CM0READBYTE_I2CM0READBYTE_of = 0
    I2CM0READ0 = 0x0164
    I2CM0READ0_I2CM0READ_of = 0
    I2CM0READ1 = 0x0165
    I2CM0READ1_I2CM0READ_of = 0
    I2CM0READ2 = 0x0166
    I2CM0READ2_I2CM0READ_of = 0
    I2CM0READ3 = 0x0167
    I2CM0READ3_I2CM0READ_of = 0
    I2CM0READ4 = 0x0168
    I2CM0READ4_I2CM0READ_of = 0
    I2CM0READ5 = 0x0169
    I2CM0READ5_I2CM0READ_of = 0
    I2CM0READ6 = 0x016a
    I2CM0READ6_I2CM0READ_of = 0
    I2CM0READ7 = 0x016b
    I2CM0READ7_I2CM0READ_of = 0
    I2CM0READ8 = 0x016c
    I2CM0READ8_I2CM0READ_of = 0
    I2CM0READ9 = 0x016d
    I2CM0READ9_I2CM0READ_of = 0
    I2CM0READ10 = 0x016e
    I2CM0READ10_I2CM0READ_of = 0
    I2CM0READ11 = 0x016f
    I2CM0READ11_I2CM0READ_of = 0
    I2CM0READ12 = 0x0170
    I2CM0READ12_I2CM0READ_of = 0
    I2CM0READ13 = 0x0171
    I2CM0READ13_I2CM0READ_of = 0
    I2CM0READ14 = 0x0172
    I2CM0READ14_I2CM0READ_of = 0
    I2CM0READ15 = 0x0173
    I2CM0READ15_I2CM0READ_of = 0
    I2CM1CTRL = 0x0174
    I2CM1CTRL_I2CM1CTRL_of = 0
    I2CM1MASK = 0x0175
    I2CM1MASK_I2CM1MASK_of = 0
    I2CM1STATUS = 0x0176
    I2CM1STATUS_I2CM1STATUS_of = 0
    I2CM1TRANCNT = 0x0177
    I2CM1TRANCNT_I2CM1TRANCNT_of = 0
    I2CM1READBYTE = 0x0178
    I2CM1READBYTE_I2CM1READBYTE_of = 0
    I2CM1READ0 = 0x0179
    I2CM1READ0_I2CM1READ_of = 0
    I2CM1READ1 = 0x017a
    I2CM1READ1_I2CM1READ_of = 0
    I2CM1READ2 = 0x017b
    I2CM1READ2_I2CM1READ_of = 0
    I2CM1READ3 = 0x017c
    I2CM1READ3_I2CM1READ_of = 0
    I2CM1READ4 = 0x017d
    I2CM1READ4_I2CM1READ_of = 0
    I2CM1READ5 = 0x017e
    I2CM1READ5_I2CM1READ_of = 0
    I2CM1READ6 = 0x017f
    I2CM1READ6_I2CM1READ_of = 0
    I2CM1READ7 = 0x0180
    I2CM1READ7_I2CM1READ_of = 0
    I2CM1READ8 = 0x0181
    I2CM1READ8_I2CM1READ_of = 0
    I2CM1READ9 = 0x0182
    I2CM1READ9_I2CM1READ_of = 0
    I2CM1READ10 = 0x0183
    I2CM1READ10_I2CM1READ_of = 0
    I2CM1READ11 = 0x0184
    I2CM1READ11_I2CM1READ_of = 0
    I2CM1READ12 = 0x0185
    I2CM1READ12_I2CM1READ_of = 0
    I2CM1READ13 = 0x0186
    I2CM1READ13_I2CM1READ_of = 0
    I2CM1READ14 = 0x0187
    I2CM1READ14_I2CM1READ_of = 0
    I2CM1READ15 = 0x0188
    I2CM1READ15_I2CM1READ_of = 0
    I2CM2CTRL = 0x0189
    I2CM2CTRL_I2CM2CTRL_of = 0
    I2CM2MASK = 0x018a
    I2CM2MASK_I2CM2MASK_of = 0
    I2CM2STATUS = 0x018b
    I2CM2STATUS_I2CM2STATUS_of = 0
    I2CM2TRANCNT = 0x018c
    I2CM2TRANCNT_I2CM2TRANCNT_of = 0
    I2CM2READBYTE = 0x018d
    I2CM2READBYTE_I2CM2READBYTE_of = 0
    I2CM2READ0 = 0x018e
    I2CM2READ0_I2CM2READ_of = 0
    I2CM2READ1 = 0x018f
    I2CM2READ1_I2CM2READ_of = 0
    I2CM2READ2 = 0x0190
    I2CM2READ2_I2CM2READ_of = 0
    I2CM2READ3 = 0x0191
    I2CM2READ3_I2CM2READ_of = 0
    I2CM2READ4 = 0x0192
    I2CM2READ4_I2CM2READ_of = 0
    I2CM2READ5 = 0x0193
    I2CM2READ5_I2CM2READ_of = 0
    I2CM2READ6 = 0x0194
    I2CM2READ6_I2CM2READ_of = 0
    I2CM2READ7 = 0x0195
    I2CM2READ7_I2CM2READ_of = 0
    I2CM2READ8 = 0x0196
    I2CM2READ8_I2CM2READ_of = 0
    I2CM2READ9 = 0x0197
    I2CM2READ9_I2CM2READ_of = 0
    I2CM2READ10 = 0x0198
    I2CM2READ10_I2CM2READ_of = 0
    I2CM2READ11 = 0x0199
    I2CM2READ11_I2CM2READ_of = 0
    I2CM2READ12 = 0x019a
    I2CM2READ12_I2CM2READ_of = 0
    I2CM2READ13 = 0x019b
    I2CM2READ13_I2CM2READ_of = 0
    I2CM2READ14 = 0x019c
    I2CM2READ14_I2CM2READ_of = 0
    I2CM2READ15 = 0x019d
    I2CM2READ15_I2CM2READ_of = 0
    PSSTATUS = 0x019e
    PSSTATUS_PS3DLLINITSTATE_of = 6
    PSSTATUS_PS2DLLINITSTATE_of = 4
    PSSTATUS_PS1DLLINITSTATE_of = 2
    PSSTATUS_PS0DLLINITSTATE_of = 0
    PIOINH = 0x019f
    PIOINH_PIOIN_of = 0
    PIOINL = 0x01a0
    PIOINL_PIOIN_of = 0
    FUSESTATUS = 0x01a1
    FUSESTATUS_FUSEBLOWERROR_bm = 0x08
    FUSESTATUS_FUSEDATAVALID_bm = 0x04
    FUSESTATUS_FUSEBLOWDONE_bm = 0x02
    FUSESTATUS_FUSEBLOWBUSY_bm = 0x01
    FUSEVALUESA = 0x01a2
    FUSEVALUESA_SELECTEDFUSEVALUES_of = 0
    FUSEVALUESB = 0x01a3
    FUSEVALUESB_SELECTEDFUSEVALUES_of = 0
    FUSEVALUESC = 0x01a4
    FUSEVALUESC_SELECTEDFUSEVALUES_of = 0
    FUSEVALUESD = 0x01a5
    FUSEVALUESD_SELECTEDFUSEVALUES_of = 0
    PROCESSMONITORSTATUS = 0x01a6
    PROCESSMONITORSTATUS_PMDONE_bm = 0x02
    PROCESSMONITORSTATUS_PMBUSY_bm = 0x01
    PMFREQA = 0x01a7
    PMFREQA_PMFREQ_of = 0
    PMFREQB = 0x01a8
    PMFREQB_PMFREQ_of = 0
    PMFREQC = 0x01a9
    PMFREQC_PMFREQ_of = 0
    SEUCOUNTH = 0x01aa
    SEUCOUNTH_SEUCOUNT_of = 0
    SEUCOUNTL = 0x01ab
    SEUCOUNTL_SEUCOUNT_of = 0
    CLKGSTATUS0 = 0x01ac
    CLKGSTATUS0_CLKG_PLL_R_CONFIG_of = 4
    CLKGSTATUS0_CLKG_CONFIG_I_PLL_of = 0
    CLKGSTATUS1 = 0x01ad
    CLKGSTATUS1_CLKG_CONFIG_I_FLL_of = 4
    CLKGSTATUS1_CLKG_CONFIG_I_CDR_of = 0
    CLKGSTATUS2 = 0x01ae
    CLKGSTATUS2_CLKG_CONFIG_P_FF_CDR_of = 4
    CLKGSTATUS2_CLKG_CONFIG_P_CDR_of = 0
    CLKGSTATUS3 = 0x01af
    CLKGSTATUS3_CLKG_LFLOSSOFLOCKCOUNT_of = 0
    CLKGSTATUS4 = 0x01b0
    CLKGSTATUS4_CLKG_CONFIG_P_PLL_of = 4
    CLKGSTATUS4_CLKG_BIASGEN_CONFIG_of = 0
    CLKGSTATUS5 = 0x01b1
    CLKGSTATUS5_CLKG_VCOCAPSELECT_of = 0
    CLKGSTATUS6 = 0x01b2
    CLKGSTATUS6_CLKG_VCOCAPSELECT0_bm = 0x80
    CLKGSTATUS6_CLKG_DATAMUXCFG_of = 5
    CLKGSTATUS6_CLKG_VCODAC_of = 0
    CLKGSTATUS7 = 0x01b3
    CLKGSTATUS7_CLKG_CONNECTCDR_bm = 0x80
    CLKGSTATUS7_CLKG_CONNECTPLL_bm = 0x40
    CLKGSTATUS7_CLKG_DISDATACOUNTERREF_bm = 0x20
    CLKGSTATUS7_CLKG_ENABLECDR_bm = 0x10
    CLKGSTATUS7_CLKG_ENABLEFD_bm = 0x08
    CLKGSTATUS7_CLKG_ENABLEPLL_bm = 0x04
    CLKGSTATUS7_CLKG_OVERRIDEVC_bm = 0x02
    CLKGSTATUS7_CLKG_REFCLKSEL_bm = 0x01
    CLKGSTATUS8 = 0x01b4
    CLKGSTATUS8_CLKG_VCORAILMODE_bm = 0x80
    CLKGSTATUS8_CLKG_ENABLE_CDR_R_bm = 0x40
    CLKGSTATUS8_CLKG_SMLOCKED_bm = 0x20
    CLKGSTATUS8_CLKG_LFINSTLOCK_bm = 0x10
    CLKGSTATUS8_CLKG_LFLOCKED_bm = 0x08
    CLKGSTATUS8_CLKG_CONFIG_FF_CAP_of = 0
    CLKGSTATUS9 = 0x01b5
    CLKGSTATUS9_CLKG_LFSTATE_of = 4
    CLKGSTATUS9_CLKG_SMSTATE_of = 0
    DLDPFECCORRECTIONCOUNTH = 0x01b6
    DLDPFECCORRECTIONCOUNTH_DLDPFECCORRECTIONCOUNT_of = 0
    DLDPFECCORRECTIONCOUNTL = 0x01b7
    DLDPFECCORRECTIONCOUNTL_DLDPFECCORRECTIONCOUNT_of = 0
    ADCSTATUSH = 0x01b8
    ADCSTATUSH_ADCBUSY_bm = 0x80
    ADCSTATUSH_ADCDONE_bm = 0x40
    ADCSTATUSH_ADCVALUE_of = 0
    ADCSTATUSL = 0x01b9
    ADCSTATUSL_ADCVALUE_of = 0
    EOMSTATUS = 0x01ba
    EOMSTATUS_EOMSMSTATE_of = 2
    EOMSTATUS_EOMBUSY_bm = 0x02
    EOMSTATUS_EOMEND_bm = 0x01
    EOMCOUTERVALUEH = 0x01bb
    EOMCOUTERVALUEH_EOMCOUNTERVALUE_of = 0
    EOMCOUTERVALUEL = 0x01bc
    EOMCOUTERVALUEL_EOMCOUNTERVALUE_of = 0
    EOMCOUNTER40MH = 0x01bd
    EOMCOUNTER40MH_EOMCOUNTER40M_of = 0
    EOMCOUNTER40ML = 0x01be
    EOMCOUNTER40ML_EOMCOUNTER40M_of = 0
    BERTSTATUS = 0x01bf
    BERTSTATUS_BERTPRBSERRORFLAG_bm = 0x04
    BERTSTATUS_BERTBUSY_bm = 0x02
    BERTSTATUS_BERTDONE_bm = 0x01
    BERTRESULT4 = 0x01c0
    BERTRESULT4_BERTERRORCOUNT_of = 0
    BERTRESULT3 = 0x01c1
    BERTRESULT3_BERTERRORCOUNT_of = 0
    BERTRESULT2 = 0x01c2
    BERTRESULT2_BERTERRORCOUNT_of = 0
    BERTRESULT1 = 0x01c3
    BERTRESULT1_BERTERRORCOUNT_of = 0
    BERTRESULT0 = 0x01c4
    BERTRESULT0_BERTERRORCOUNT_of = 0
    ROM = 0x01c5
    ROM_ROMREG_of = 0
    PORBOR = 0x01c6
    PORBOR_PORC_bm = 0x40
    PORBOR_PORB_bm = 0x20
    PORBOR_PORA_bm = 0x10
    PORBOR_BODC_bm = 0x04
    PORBOR_BODB_bm = 0x02
    PORBOR_BODA_bm = 0x01
    PUSMSTATUS = 0x01c7
    PUSMSTATUS_PUSMSTATE_of = 0
    PUSMACTIONS = 0x01c8
    PUSMACTIONS_PUSMPLLTIMEOUTACTION_bm = 0x20
    PUSMACTIONS_PUSMDLLTIMEOUTACTION_bm = 0x10
    PUSMACTIONS_PUSMCHANNELSTIMEOUTACTION_bm = 0x08
    PUSMACTIONS_PUSMBROWNOUTACTION_bm = 0x04
    PUSMACTIONS_PUSMPLLWATCHDOGACTION_bm = 0x02
    PUSMACTIONS_PUSMDLLWATCHDOGACTION_bm = 0x01
    TOVALUE = 0x01c9
    TOVALUE_TOVAL_of = 0
    SCSTATUS = 0x01ca
    SCSTATUS_SCPARITYVALID_bm = 0x01
    FASTATE = 0x01cb
    FASTATE_FASTATE_of = 0
    FACOUNTER = 0x01cc
    FACOUNTER_FACOUNTER_of = 0
    CONFIGERRORCOUNTERH = 0x01cd
    CONFIGERRORCOUNTERH_CONFIGERRORCOUNTER_of = 0
    CONFIGERRORCOUNTERL = 0x01ce
    CONFIGERRORCOUNTERL_CONFIGERRORCOUNTER_of = 0
    MAX_REG = 0x01cf

    REG2STR = ['CHIPID0', 'CHIPID1', 'CHIPID2', 'CHIPID3', 'USERID0',
               'USERID1', 'USERID2', 'USERID3', 'DACCAL0', 'DACCAL1', 'DACCAL2', 'ADCCAL0',
               'ADCCAL1', 'ADCCAL2', 'ADCCAL3', 'ADCCAL4', 'ADCCAL5', 'ADCCAL6', 'ADCCAL7',
               'ADCCAL8', 'ADCCAL9', 'ADCCAL10', 'ADCCAL11', 'ADCCAL12', 'ADCCAL13',
               'ADCCAL14', 'TEMPCALH', 'TEMPCALL', 'VREFCNTR', 'CURDACCALH', 'CURDACCALL',
               'RESERVED0', 'CLKGCONFIG0', 'CLKGCONFIG1', 'CLKGPLLRES', 'CLKGPLLINTCUR',
               'CLKGPLLPROPCUR', 'CLKGCDRPROPCUR', 'CLKGCDRINTCUR', 'CLKGCDRFFPROPCUR',
               'CLKGFLLINTCUR', 'CLKGFFCAP', 'CLKGCNTOVERRIDE', 'CLKGOVERRIDECAPBANK',
               'CLKGWAITTIME', 'CLKGLFCONFIG0', 'CLKGLFCONFIG1', 'FAMAXHEADERFOUNDCOUNT',
               'FAMAXHEADERFOUNDCOUNTAFTERNF', 'FAMAXHEADERNOTFOUNDCOUNT',
               'FAFAMAXSKIPCYCLECOUNTAFTERNF', 'PSDLLCONFIG', 'EPRXDLLCONFIG',
               'FORCEENABLE', 'CHIPADR', 'EQCONFIG', 'EQRES', 'LDCONFIGH', 'LDCONFIGL',
               'REFCLK', 'SCCONFIG', 'RESETCONFIG', 'PGCONFIG', 'I2CMTRANSCONFIG',
               'I2CMTRANSADDRESS', 'I2CMTRANSCTRL', 'I2CMTRANSDATA0', 'I2CMTRANSDATA1',
               'I2CMTRANSDATA2', 'I2CMTRANSDATA3', 'I2CMTRANSDATA4', 'I2CMTRANSDATA5',
               'I2CMTRANSDATA6', 'I2CMTRANSDATA7', 'I2CMTRANSDATA8', 'I2CMTRANSDATA9',
               'I2CMTRANSDATA10', 'I2CMTRANSDATA11', 'I2CMTRANSDATA12', 'I2CMTRANSDATA13',
               'I2CMTRANSDATA14', 'I2CMTRANSDATA15', 'PIODIRH', 'PIODIRL', 'PIOOUTH',
               'PIOOUTL', 'PIOPULLENAH', 'PIOPULLENAL', 'PIOUPDOWNH', 'PIOUPDOWNL',
               'PIODRIVESTRENGTHH', 'PIODRIVESTRENGTHL', 'PS0CONFIG', 'PS0DELAY',
               'PS0OUTDRIVER', 'PS1CONFIG', 'PS1DELAY', 'PS1OUTDRIVER', 'PS2CONFIG',
               'PS2DELAY', 'PS2OUTDRIVER', 'PS3CONFIG', 'PS3DELAY', 'PS3OUTDRIVER',
               'DACCONFIGH', 'DACCONFIGL', 'CURDACVALUE', 'CURDACCHN', 'EPCLK0CHNCNTRH',
               'EPCLK0CHNCNTRL', 'EPCLK1CHNCNTRH', 'EPCLK1CHNCNTRL', 'EPCLK2CHNCNTRH',
               'EPCLK2CHNCNTRL', 'EPCLK3CHNCNTRH', 'EPCLK3CHNCNTRL', 'EPCLK4CHNCNTRH',
               'EPCLK4CHNCNTRL', 'EPCLK5CHNCNTRH', 'EPCLK5CHNCNTRL', 'EPCLK6CHNCNTRH',
               'EPCLK6CHNCNTRL', 'EPCLK7CHNCNTRH', 'EPCLK7CHNCNTRL', 'EPCLK8CHNCNTRH',
               'EPCLK8CHNCNTRL', 'EPCLK9CHNCNTRH', 'EPCLK9CHNCNTRL', 'EPCLK10CHNCNTRH',
               'EPCLK10CHNCNTRL', 'EPCLK11CHNCNTRH', 'EPCLK11CHNCNTRL', 'EPCLK12CHNCNTRH',
               'EPCLK12CHNCNTRL', 'EPCLK13CHNCNTRH', 'EPCLK13CHNCNTRL', 'EPCLK14CHNCNTRH',
               'EPCLK14CHNCNTRL', 'EPCLK15CHNCNTRH', 'EPCLK15CHNCNTRL', 'EPCLK16CHNCNTRH',
               'EPCLK16CHNCNTRL', 'EPCLK17CHNCNTRH', 'EPCLK17CHNCNTRL', 'EPCLK18CHNCNTRH',
               'EPCLK18CHNCNTRL', 'EPCLK19CHNCNTRH', 'EPCLK19CHNCNTRL', 'EPCLK20CHNCNTRH',
               'EPCLK20CHNCNTRL', 'EPCLK21CHNCNTRH', 'EPCLK21CHNCNTRL', 'EPCLK22CHNCNTRH',
               'EPCLK22CHNCNTRL', 'EPCLK23CHNCNTRH', 'EPCLK23CHNCNTRL', 'EPCLK24CHNCNTRH',
               'EPCLK24CHNCNTRL', 'EPCLK25CHNCNTRH', 'EPCLK25CHNCNTRL', 'EPCLK26CHNCNTRH',
               'EPCLK26CHNCNTRL', 'EPCLK27CHNCNTRH', 'EPCLK27CHNCNTRL', 'EPCLK28CHNCNTRH',
               'EPCLK28CHNCNTRL', 'RESERVED1', 'EPTXDATARATE', 'EPTXCONTROL',
               'EPTX10ENABLE', 'EPTX32ENABLE', 'EPTXECCHNCNTR', 'EPTX00CHNCNTR',
               'EPTX01CHNCNTR', 'EPTX02CHNCNTR', 'EPTX03CHNCNTR', 'EPTX10CHNCNTR',
               'EPTX11CHNCNTR', 'EPTX12CHNCNTR', 'EPTX13CHNCNTR', 'EPTX20CHNCNTR',
               'EPTX21CHNCNTR', 'EPTX22CHNCNTR', 'EPTX23CHNCNTR', 'EPTX30CHNCNTR',
               'EPTX31CHNCNTR', 'EPTX32CHNCNTR', 'EPTX33CHNCNTR', 'EPTX01_00CHNCNTR',
               'EPTX03_02CHNCNTR', 'EPTX11_10CHNCNTR', 'EPTX13_12CHNCNTR',
               'EPTX21_20CHNCNTR', 'EPTX23_22CHNCNTR', 'EPTX31_30CHNCNTR',
               'EPTX33_32CHNCNTR', 'EPRX0CONTROL', 'EPRX1CONTROL', 'EPRX2CONTROL',
               'EPRX3CONTROL', 'EPRX4CONTROL', 'EPRX5CONTROL', 'EPRX6CONTROL',
               'EPRXECCONTROL', 'EPRX00CHNCNTR', 'EPRX01CHNCNTR', 'EPRX02CHNCNTR',
               'EPRX03CHNCNTR', 'EPRX10CHNCNTR', 'EPRX11CHNCNTR', 'EPRX12CHNCNTR',
               'EPRX13CHNCNTR', 'EPRX20CHNCNTR', 'EPRX21CHNCNTR', 'EPRX22CHNCNTR',
               'EPRX23CHNCNTR', 'EPRX30CHNCNTR', 'EPRX31CHNCNTR', 'EPRX32CHNCNTR',
               'EPRX33CHNCNTR', 'EPRX40CHNCNTR', 'EPRX41CHNCNTR', 'EPRX42CHNCNTR',
               'EPRX43CHNCNTR', 'EPRX50CHNCNTR', 'EPRX51CHNCNTR', 'EPRX52CHNCNTR',
               'EPRX53CHNCNTR', 'EPRX60CHNCNTR', 'EPRX61CHNCNTR', 'EPRX62CHNCNTR',
               'EPRX63CHNCNTR', 'EPRXECCHNCNTR', 'EPRXEQ10CONTROL', 'EPRXEQ32CONTROL',
               'EPRXEQ54CONTROL', 'EPRXEQ6CONTROL', 'POWERUP0', 'POWERUP1', 'POWERUP2',
               'I2CM0CONFIG', 'I2CM0ADDRESS', 'I2CM0DATA0', 'I2CM0DATA1', 'I2CM0DATA2',
               'I2CM0DATA3', 'I2CM0CMD', 'I2CM1CONFIG', 'I2CM1ADDRESS', 'I2CM1DATA0',
               'I2CM1DATA1', 'I2CM1DATA2', 'I2CM1DATA3', 'I2CM1CMD', 'I2CM2CONFIG',
               'I2CM2ADDRESS', 'I2CM2DATA0', 'I2CM2DATA1', 'I2CM2DATA2', 'I2CM2DATA3',
               'I2CM2CMD', 'EPRXTRAIN10', 'EPRXTRAIN32', 'EPRXTRAIN54', 'EPRXTRAINEC6',
               'FUSECONTROL', 'FUSEBLOWDATAA', 'FUSEBLOWDATAB', 'FUSEBLOWDATAC',
               'FUSEBLOWDATAD', 'FUSEBLOWADDH', 'FUSEBLOWADDL', 'FUSEMAGIC', 'ADCSELECT',
               'ADCMON', 'ADCCONFIG', 'EOMCONFIGH', 'EOMCONFIGL', 'EOMVOFSEL',
               'PROCESSANDSEUMONITOR', 'ULDATASOURCE0', 'ULDATASOURCE1', 'ULDATASOURCE2',
               'ULDATASOURCE3', 'ULDATASOURCE4', 'ULDATASOURCE5', 'DPDATAPATTERN3',
               'DPDATAPATTERN2', 'DPDATAPATTERN1', 'DPDATAPATTERN0', 'EPRXPRBS3',
               'EPRXPRBS2', 'EPRXPRBS1', 'EPRXPRBS0', 'BERTSOURCE', 'BERTCONFIG',
               'BERTDATAPATTERN3', 'BERTDATAPATTERN2', 'BERTDATAPATTERN1',
               'BERTDATAPATTERN0', 'RST0', 'RST1', 'RST2', 'POWERUP3', 'POWERUP4',
               'CLKTREE', 'DATAPATH', 'TO0SEL', 'TO1SEL', 'TO2SEL', 'TO3SEL', 'TO4SEL',
               'TO5SEL', 'TODRIVINGSTRENGTH', 'TO4DRIVER', 'TO5DRIVER', 'TOPREEMP',
               'CONFIGPINS', '-', '-', '-', 'I2CSLAVEADDRESS', 'EPRX0LOCKED',
               'EPRX0CURRENTPHASE10', 'EPRX0CURRENTPHASE32', 'EPRX1LOCKED',
               'EPRX1CURRENTPHASE10', 'EPRX1CURRENTPHASE32', 'EPRX2LOCKED',
               'EPRX2CURRENTPHASE10', 'EPRX2CURRENTPHASE32', 'EPRX3LOCKED',
               'EPRX3CURRENTPHASE10', 'EPRX3CURRENTPHASE32', 'EPRX4LOCKED',
               'EPRX4CURRENTPHASE10', 'EPRX4CURRENTPHASE32', 'EPRX5LOCKED',
               'EPRX5CURRENTPHASE10', 'EPRX5CURRENTPHASE32', 'EPRX6LOCKED',
               'EPRX6CURRENTPHASE10', 'EPRX6CURRENTPHASE32', 'EPRXECCURRENTPHASE',
               'EPRX0DLLSTATUS', 'EPRX1DLLSTATUS', 'EPRX2DLLSTATUS', 'EPRX3DLLSTATUS',
               'EPRX4DLLSTATUS', 'EPRX5DLLSTATUS', 'EPRX6DLLSTATUS', 'I2CM0CTRL',
               'I2CM0MASK', 'I2CM0STATUS', 'I2CM0TRANCNT', 'I2CM0READBYTE', 'I2CM0READ0',
               'I2CM0READ1', 'I2CM0READ2', 'I2CM0READ3', 'I2CM0READ4', 'I2CM0READ5',
               'I2CM0READ6', 'I2CM0READ7', 'I2CM0READ8', 'I2CM0READ9', 'I2CM0READ10',
               'I2CM0READ11', 'I2CM0READ12', 'I2CM0READ13', 'I2CM0READ14', 'I2CM0READ15',
               'I2CM1CTRL', 'I2CM1MASK', 'I2CM1STATUS', 'I2CM1TRANCNT', 'I2CM1READBYTE',
               'I2CM1READ0', 'I2CM1READ1', 'I2CM1READ2', 'I2CM1READ3', 'I2CM1READ4',
               'I2CM1READ5', 'I2CM1READ6', 'I2CM1READ7', 'I2CM1READ8', 'I2CM1READ9',
               'I2CM1READ10', 'I2CM1READ11', 'I2CM1READ12', 'I2CM1READ13', 'I2CM1READ14',
               'I2CM1READ15', 'I2CM2CTRL', 'I2CM2MASK', 'I2CM2STATUS', 'I2CM2TRANCNT',
               'I2CM2READBYTE', 'I2CM2READ0', 'I2CM2READ1', 'I2CM2READ2', 'I2CM2READ3',
               'I2CM2READ4', 'I2CM2READ5', 'I2CM2READ6', 'I2CM2READ7', 'I2CM2READ8',
               'I2CM2READ9', 'I2CM2READ10', 'I2CM2READ11', 'I2CM2READ12', 'I2CM2READ13',
               'I2CM2READ14', 'I2CM2READ15', 'PSSTATUS', 'PIOINH', 'PIOINL', 'FUSESTATUS',
               'FUSEVALUESA', 'FUSEVALUESB', 'FUSEVALUESC', 'FUSEVALUESD',
               'PROCESSMONITORSTATUS', 'PMFREQA', 'PMFREQB', 'PMFREQC', 'SEUCOUNTH',
               'SEUCOUNTL', 'CLKGSTATUS0', 'CLKGSTATUS1', 'CLKGSTATUS2', 'CLKGSTATUS3',
               'CLKGSTATUS4', 'CLKGSTATUS5', 'CLKGSTATUS6', 'CLKGSTATUS7', 'CLKGSTATUS8',
               'CLKGSTATUS9', 'DLDPFECCORRECTIONCOUNTH', 'DLDPFECCORRECTIONCOUNTL',
               'ADCSTATUSH', 'ADCSTATUSL', 'EOMSTATUS', 'EOMCOUTERVALUEH',
               'EOMCOUTERVALUEL', 'EOMCOUNTER40MH', 'EOMCOUNTER40ML', 'BERTSTATUS',
               'BERTRESULT4', 'BERTRESULT3', 'BERTRESULT2', 'BERTRESULT1', 'BERTRESULT0',
               'ROM', 'PORBOR', 'PUSMSTATUS', 'PUSMACTIONS', 'TOVALUE', 'SCSTATUS',
               'FASTATE', 'FACOUNTER', 'CONFIGERRORCOUNTERH', 'CONFIGERRORCOUNTERL']

    def get_gui_init_map(self):
        gui_initialization_map = []
        gui_initialization_map.clear()
        gui_initialization_map[self.REFCLK] = self.REFCLK_REFCLKACBIAS_bm | self.REFCLK_REFCLKTERM_bm
        gui_initialization_map[self.CLKGCONFIG0] = (15 << self.CLKGCONFIG0_CLKGCALIBRATIONENDOFCOUNT_of | 8 << self.CLKGCONFIG0_CLKGBIASGENCONFIG_of)
        gui_initialization_map[self.CLKGCONFIG1] = (self.CLKGCONFIG1_CLKGCDRRES_bm | 4 << self.CLKGCONFIG1_CLKGVCODAC_of)
        gui_initialization_map[self.CLKGPLLINTCUR] = (5 <<self.CLKGPLLINTCUR_CLKGPLLINTCURWHENLOCKED_of | 5 <<self.CLKGPLLINTCUR_CLKGPLLINTCUR_of)
        gui_initialization_map[self.CLKGPLLPROPCUR] = (5 <<self.CLKGPLLPROPCUR_CLKGPLLPROPCURWHENLOCKED_of | 5 <<self.CLKGPLLPROPCUR_CLKGPLLPROPCUR_of)
        gui_initialization_map[self.CLKGPLLRES] = (4 <<self.CLKGPLLRES_CLKGPLLRESWHENLOCKED_of | 4 <<self.CLKGPLLRES_CLKGPLLRES_of)
        gui_initialization_map[self.CLKGFFCAP] = (6 <<self.CLKGFFCAP_CLKGFEEDFORWARDCAPWHENLOCKED_of | 6 <<self.CLKGFFCAP_CLKGFEEDFORWARDCAP_of)
        gui_initialization_map[self.CLKGCDRINTCUR] = (5 <<self.CLKGCDRINTCUR_CLKGCDRINTCURWHENLOCKED_of | 5 <<self.CLKGCDRINTCUR_CLKGCDRINTCUR_of)
        gui_initialization_map[self.CLKGFLLINTCUR] = (0 <<self.CLKGFLLINTCUR_CLKGFLLINTCURWHENLOCKED_of | 0xF <<self.CLKGCDRINTCUR_CLKGCDRINTCUR_of)
        gui_initialization_map[self.CLKGCDRPROPCUR] =  (5 <<self.CLKGCDRPROPCUR_CLKGCDRPROPCURWHENLOCKED_of | 5 <<self.CLKGCDRPROPCUR_CLKGCDRPROPCUR_of)
        gui_initialization_map[self.CLKGCDRFFPROPCUR] =  (5 <<self.CLKGCDRFFPROPCUR_CLKGCDRFEEDFORWARDPROPCURWHENLOCKED_of | 5 <<self.CLKGCDRFFPROPCUR_CLKGCDRFEEDFORWARDPROPCUR_of)
        gui_initialization_map[self.CLKGLFCONFIG0] = (self.CLKGLFCONFIG0_CLKGLOCKFILTERENABLE_bm | 9<<self.CLKGLFCONFIG0_CLKGLOCKFILTERLOCKTHRCOUNTER_of)
        gui_initialization_map[self.CLKGLFCONFIG1] = (9<<self.CLKGLFCONFIG1_CLKGLOCKFILTERRELOCKTHRCOUNTER_of | 9<<self.CLKGLFCONFIG1_CLKGLOCKFILTERUNLOCKTHRCOUNTER_of)
        gui_initialization_map[self.CLKGWAITTIME] = (0xa<<self.CLKGWAITTIME_CLKGWAITCDRTIME_of)
        gui_initialization_map[self.PSDLLCONFIG] = 0xa
        gui_initialization_map[self.FAMAXHEADERFOUNDCOUNT] = 0x0a
        gui_initialization_map[self.FAMAXHEADERFOUNDCOUNTAFTERNF] = 0x1a
        gui_initialization_map[self.FAMAXHEADERNOTFOUNDCOUNT] = 0x2a
        gui_initialization_map[self.FAFAMAXSKIPCYCLECOUNTAFTERNF] = 0x3a
        gui_initialization_map[self.LDCONFIGH] = (int(64)&0x7F)<<self.LDCONFIGH_LDMODULATIONCURRENT_of
        gui_initialization_map[self.LDCONFIGL] = int(32) << self.LDCONFIGL_LDEMPHASISAMP_of
        gui_initialization_map[self.EQCONFIG] = 3 << self.EQCONFIG_EQATTENUATION_of | 0 << EQCONFIG_EQCAP_of
        gui_initialization_map[self.EQRES] = 0 << self.EQRES_EQRES3_of | 0 << self.EQRES_EQRES2_of | 0 << self.EQRES_EQRES1_of | 0 << vEQRES_EQRES0_of
        return gui_initialization_map
